/*
	Berechnung der Mondparameter zur Berechnung der Mondposition und
	weitere Daten wie größe am Himmel und Entfernung und Phase.
*/
var LCTR = [];
var LCTS = [];
var saveLCTR = new Array(0.0, "", "", 0, 0, 0);
var saveLCTS = new Array(0.0, "", "", 0, 0, 0);
var jdMoonRise = 0.0;
var jdMoonSet = 0.0;
var moonRiseAzDec = [];
var moonSetAzDec = [];
var moonDist = 0.0;
var moonDia = 0.0;
// ... Ausgabe der korregierten Länge des Mondes
var LStrich = 0.0;
// ... Ausgabe des korregierten Längengrades des Knoten des Mondes N'
var NStrich = 0.0;
// ... Ausgabe der korregierten durchschnittlichen Anomalie des Mondes
var mStrichM = 0.0;
// Berechne den arctan von X/Y (ecliptic Längengrad)und korregiere ihn mit 180/360 Grad um Ihn in den bewünschten
// Bereich zu bekommen
// Calculate the arctan of X/Y (ecliptic longitude)and correct it with 180/360 degrees around it in the desired
// To get area
var LDM = 0.0;
// Berechne den ecliptic Breitengrad des Mondes
// Calculate the ecliptic latitude of the moon
var BM = 0.0;
// Gesicherter JD um eine Berechnung mit selbem Datum und Uhrzeit zu verhindern
var jdltSave = 0.0;

var jdMoonRiseSave = 0.0;
var jdMonnSetSave = 0.0;

function moonParameters(jdlt, ra, dec, dst, tz, longitude, latitude, sendString){
	var JDLT	=	Number(jdlt);		// Julianisches Datum der Berechnung mit TZ=0 und DST=0,
													// also UT in Greenwich
													// Julian date of calculation with TZ=0 and DST=0,
													// also UT in Greenwich
	var daysSinceEpoch = 0.0;		// Anzahl der Tage von der letzten Epoche bis zum aktuellen Datum
													// Number of days from last epoch to current date
	var CENTURY = [];					// Array für den dezimalen Anteil des vergangenen Jahrhunderts
													// Array for the decimal fraction of the past century
	var jdDate = [];						// Array für die einzelnen Datumsdaten des JD  
	var jdTime = [];						// Array für die einzelnen Uhrzeiten des JD  
	var jdDay = 0;							// Datumsdaten aus dem JD des Berechnungsdatums
	var jdMonth = 0;						// Date data from the JD of the calculation date
	var jdYear = 0;
	var jdHour = 0;
	var jdMinute = 0;
	var jdSecond = 0;
	var jdMsecond = 0;
	// Aus dem JD des Berechnungsdatums die einzelnen Datums Daten errechnen,
	// indem das JD in ein Datum konvertiert wird, der Tag hat als Dezimalstellen die
	// Uhrzeit ...
	jdDate = julianDate2Date(JDLT);
	// jdDate[0] ist der Tag als Ganzzahlanteil, mit der Uhrzeit des Tages als Nachkommaanteil ...
	jdDay = parseInt(jdDate[0] - decPart(jdDate[0]));
	jdMonth = parseInt(jdDate[1]);
	jdYear = parseInt(jdDate[2]);
	console.log("Tag =" + jdDay);
	console.log("Monat =" + jdMonth);
	console.log("jahr =" + jdYear);
	// Aus dem JD des Berechnungsdatums die einzelnen Uhrzeit Daten errechnen,
	// indem der jdDate[0] Nachkommaanteil in Uhrzeit konvertiert wird ...
	jdTime = percentageOfDecimal2Time(decPart(jdDate[0]), "array");
	jdHour = parseInt(jdTime[0]);
	jdMinute = parseInt(jdTime[1]);
	jdSecond = parseInt(jdTime[2]);
	jdMsecond = parseInt(jdTime[3]);
	
	var jdDateUT = calcJD(jdDay, jdMonth, jdYear, jdHour,jdMinute, jdSecond, jdMsecond, dst, tz);
	console.log("JD UT=" + jdDateUT);
	// Wenn der aktuelle Tag verschieden vom letzlich gespeicherten, dann wird eine neue
	// Berechnung von Mondaufgang und Untergang notwendig ...
	if (jdltSave != jdlt){
		jdltSave = jdlt;
													
		
		if ( jdDay != LCTR[3] ){
			
			// ... und berechne dann den neuen Mond Aufgang ...
			// . . . and then work out the new moon up . . .
			LCTR = moonriseLocalTime(jdDay, jdMonth, jdYear, 
														dst, tz, longitude, latitude);
			
			saveLCTR = LCTR;
			
			// ... und den Monduntergang, bevor die Sonderfälle berechnet werden ...
			// . . . and the moonset before the special cases are calculated . . .
			LCTS = moonsetLocalTime(jdDay, jdMonth, jdYear, 
														dst, tz, longitude, latitude);

			saveLCTS = LCTS;


			// ... nun das Julianisches Datum des Mondaufgangs ermitteln ...
			// . . . now determine the Julian date of moonrise . . .
			jdMoonRise = calcJD(LCTR[3], LCTR[4], LCTR[5], LCTR[0], 0, 0, 0, 0, 0);
			//console.log("JD Moonrise=" + jdMoonRise + " - date=" + julianDate2Date(jdMoonRise) + " Time=" + percentageOfDecimal2Time(decPart(julianDate2Date(jdMoonRise)[0]), "string") );
			// ... nun das Julianisches Datum des Monduntergangs in Greenwich ermitteln ...
			// . . . now determine the Julian date of the moonset in Greenwich . . .
			jdMoonSet = calcJD(LCTS[3], LCTS[4], LCTS[5], LCTS[0], 0, 0, 0, 0, 0);
			//console.log("JD Moonset=" + jdMoonSet + " - date=" + julianDate2Date(jdMoonSet) + " Time=" + percentageOfDecimal2Time(decPart(julianDate2Date(jdMoonSet)[0]), "string") );
			//console.log("JD Actual Date=" + jdlt + " - date=" + julianDate2Date(jdlt) + " Time=" + percentageOfDecimal2Time(decPart(julianDate2Date(jdlt)[0]), "string") );
		}
		
		// Berechnung des Azimuts in dezimalen Grad für den Aufgang ...
		// Calculation of the azimuth in decimal degrees for the rise . . .
		// Berechne aus Stundenwinkel, Deklination und Breitengrad die Höhe eines
		// Der Azimuth in dezimalen Grad
		// Index [0];
		// Objekts (Mond ... Sterne ....) über dem Horizont ...
		// Die Höhe über dem Horizont in °, ', ''
		// Index [1];
		// Die Höhe (Deklination)über dem Horizont in dezimalen Grad ...
		// Index [2];
		moonRiseAzDec = moonRiseAz(jdDay, jdMonth, jdYear, 
															dst, tz, longitude, latitude);
		//console.log("Rise AZ + Dec=" + moonRiseAzDec);
		// Berechnung des Azimuts in dezimalen Grad für den Untergang ...
		// Calculation of the azimuth in decimal degrees for the set . . .
		// Berechne aus Stundenwinkel, Deklination und Breitengrad die Höhe eines
		// Der Azimuth in dezimalen Grad
		// Index [0];
		// Objekts (Mond ... Sterne ....) über dem Horizont ...
		// Die Höhe über dem Horizont in °, ', ''
		// Index [1];
		// Die Höhe (Deklination)über dem Horizont in dezimalen Grad ...
		// Index [2];
		moonSetAzDec = moonSetAz(jdDay, jdMonth, jdYear, 
														dst, tz, longitude, latitude);
		console.log("Tag=" + LCTR[3] + "jd=" + jdMoonRise + " Rise=",moonRiseAzDec[0], LCTR, saveLCTR);
		console.log("Tag=" + LCTS[3] + "jd=" + jdMoonSet + " Set=", moonSetAzDec[0], LCTS, saveLCTS);	
		
		//console.log("Set AZ + Dec=" + moonSetAzDec);
		// Berechnung des Abstands des Mondes von der Erde hier um 00:00:00.000 Uhr des Tages
		// Calculation of the distance of the moon from earth here at 00:00:00. 000 o'clock of the day
		moonDist = moonDistance(0, 0, 0, dst, tz, jdDay, jdMonth, jdYear);
		//console.log("Distance=" + moonDist);				
		// Berechnung des Abstands des Mondes von der Erde hier um 00:00:00.000 Uhr des Tages
		// Calculation of the distance of the moon from earth here at 00:00:00. 000 o'clock of the day
		moonDia = moonDiameter(0, 0, 0, dst, tz, jdDay, jdMonth, jdYear);		
		//console.log("Diameter=" + moonDia);
		var moonPos = precMoonPos(jdHour, jdMinute, jdSecond, jdMsecond, jdDay, jdMonth, jdYear, dst, tz);
		//console.log(moonPos);
		// Berechne die Universalzeit (UT)anhand des aktuellen Berechnungsdatums mit Julianischem Datum
		// Das Ergebnis ist ein Array mit den Werten und Format:
		// jdDate[0] = Tag des Datums und der Uhrzeit als Nachkommastellen
		// jdDate[1] = Monat
		// jdDate[2] = Jahr
		// Calculate the Universal Time (UT) using the current calculation date with Julian date
		// The result is an array with the values and format:
		// jdDate[0] = day of date and time as decimal places
		// jdDate[1] = month
		// jdDate[2] = year
		var jdDateUT2 = calcJD2Date(Number(jdDateUT));
		console.log("UT Date=" + jdDateUT2);
		// Die Nachkommastellen des Julianischen Datums ermitteln ...
		// Identify the decimals of the Julian date. . .
		var decUT = jdDateUT2[0] - Math.floor(jdDateUT2[0]);
		console.log("Dec UT=" + decUT);
		var UT = decUT * 24.0;
		console.log("UT=" + UT);
		var arrUT = percentageOfDecimal2Time(decUT, "array");
		var valArrUT = time2Dectime(arrUT[0], arrUT[1], arrUT[2], arrUT[3]);
		// Berechne die Tage des Berechnungsjahres vom 0.1.2010 00:00:00 Uhr Greenwich an.
		//var daysSinceEpoche = (calcJD(jdDay, jdMonth, jdYear, jdHour, jdMinute, jdSecond, jdMsecond, 0, 0)- 
																					//calcJD(0, 1, 2010, 0, 0, 0, 0, 0, 0)+  valArrUT/24.0;
		//var daysSinceEpoche = 	calcDaysSinceEpoch(2010, jdDay, jdMonth, jdYear);
		var daysSinceEpoche = 367 * jdYear - iInt(7 * ( jdYear + (jdMonth + 9) / 12 ) / 4) -  iInt(3 * ( ( jdYear + (jdMonth-9)/7 ) / 100 + 1 ) / 4) + iInt(275*jdMonth / 9)  + jdDay - 730515;
											  d = d + UT/24.0;
		console.log("Days=" + daysSinceEpoche);
		
		// ************************************* Mondpositionen berechnen *************************************************
						
		// Berechnen der durchschnittlichen Länge l des Mondes l ...
		var averageLMoon = moonAverageLengthL(daysSinceEpoche, l0_moon);
		//console.log("averageLMoon=" + averageLMoon);
		// ... und die durchschnittliche Anomalie des Mondes Mm...
		var averageAnomalyMoon = moonAverageAnomaly(averageLMoon, daysSinceEpoche);
		//console.log("averageAnomalyMoon=" + averageAnomalyMoon);
		// Berechne die Hilfsgroesse N anhand der vergangenen Tage seit
		// Epochenbeginn
		var N = calculateN(daysSinceEpoche);
		//console.log("N=" + N);
		// Berechnung der 2-ten mittleren Sonne anhand der Hilfsgroesse N.
		var Msun2 = mediumSun2(N, epsilong, omegag );
		//console.log("Msun2=" + Msun2);
		// Berechnung von Ec als Hilfsgrösse
		var Ec = calculateEc(e, Msun2);
		//console.log("Ec=" + Ec);
		// Berechnet den ekliptischen Längengrad der Sonne
		var LDSun = lambdaSun(N, Ec, epsilong);
		//console.log("LDSun=" + LDSun);
		// ... und die Jahregleichung der mittleren Sonne ..
		var Ye = yearEquation(Msun2);
		//console.log("Ye=" + Ye);
		// ... und die dritte Korrektur der mittleren Sonne ...
		var A3 = a3(Msun2);
		//console.log("A3=" + A3);
		// ... und die Korrektur der Evektion des Mondes Ev ...
		var evectionMoon = correctionsForEvection(Number(averageAnomalyMoon), Number(averageLMoon),  Number(LDSun));
		//console.log("evectionMoon=" + evectionMoon);
		// ... Ausgabe der korregierten durchschnittlichen Anomalie des Mondes
		mStrichM = moonAverageAnomalyCorrected(averageAnomalyMoon, evectionMoon, Ye, A3);
		//console.log("mStrichM=" + mStrichM);
		// Berechnen der durchschnittlichen Länge N des Mondes N  ...
		var averageNMoon = moonAverageLengthN(daysSinceEpoche);
		//console.log("averageNMoon=" + averageNMoon);
		// ... Ausgabe des korregierten Längengrades des Knoten des Mondes N'
		NStrich = correctedLongitudeOfTheMoon(averageNMoon, Msun2);
		//console.log("NStrich=" + NStrich);
		// ... Ausgabe der Korrektur der Gleichung der Mitte
		var ECM = equationOfMiddle(mStrichM);
		//console.log("ECM=" + ECM);
		// ... Ausgabe der Korrektur der Länge des Mondes
		var A4 = a4(mStrichM);
		//console.log("A4=" + A4);
		// ... Ausgabe der korregierten Länge des Mondes
		LStrich = correctedLengthOfTheMoon(averageLMoon, evectionMoon, ECM, Ye,  A4);
		//console.log("LStrich=" + LStrich);
		// ... Ausgabe der Korrektur V für Variation der wahren  Länge des Mondes
		var V = variationV(LStrich, LDSun);
		//console.log("V=" + V);
		// ... Ausgabe der wahren Längengrades l" des Mondes
		var LStrichStrich = trueLongitudeOfTheMoon(LStrich, V);
		//console.log("LStrichStrich=" + LStrichStrich);
		// Berechnung des X/Y-Wertes für den Längengrad des Mondes aus der Ekliptik
		// xy = Array mit 2 Werten
		// xy[1] = X xy[0] = Y
		// Calculation of the X/Y value for the longitude of the moon from the ecliptic
		// xy = Array with 2 values
		// xy[1] = X xy[0] = Y
		var xy = valueXYforEclipticLongitudeOfTheMoon(LStrichStrich, NStrich);
		//console.log("x=" + xy[1] + " y=" + xy[0]);
		// Berechne den arctan von X/Y (ecliptic Längengrad)und korregiere ihn mit 180/360 Grad um Ihn in den bewünschten
		// Bereich zu bekommen
		// Calculate the arctan of X/Y (ecliptic longitude)and correct it with 180/360 degrees around it in the desired
		// To get area
		LDM = eclipticLongitudeOfTheMoon(xy[1], xy[0], NStrich);
		//console.log("LDM=" + LDM);
		// Berechne den ecliptic Breitengrad des Mondes
		// Calculate the ecliptic latitude of the moon
		BM = eclipticLatitudeOfTheMoon(LStrichStrich, NStrich, i_moon);
		//console.log("BM=" + BM);
		// Berechnung der aktuellen Position des Mondes am Himmel
		calcAzimuthAndAltitude(jdlt, jdMoonRise, jdMoonSet, LCTR[3], LCTS[3], jdDay, jdMonth, jdYear, 
												jdHour, jdMinute, jdSecond, jdMsecond, dst, tz, longitude, latitude,
												LDM, BM, averageLMoon, UT, daysSinceEpoche);
		/*
			Berechnung der stündlichen Bewegung des Mondes in ekliptischer Länge (lambda)
			und Breite (beta)
			
			lambdaM			=	Längengrad des Mondes als dezimale Grad und Number
										objLDM.value = eclipticLongitudeOfTheMoon(objX.value, objY.value, objNStrich.value);
										var xy = valueXYforEclipticLongitudeOfTheMoon(objLStrichStrich.value, objNStrich.value);
										
			betaM				=	Breitengrad des Mondes als dezimale Grad und Number
										objBM.value = eclipticLatitudeOfTheMoon(objLStrichStrich.value, objNStrich.value, i_moon);
										objLStrichStrich.value = trueLongitudeOfTheMoon(objLStrich.value, objV.value);
										objV.value = variationV(objLStrich.value, objLDSun.value);
										
			lStrich				=	Korregierter ekliptischer Längengrad des Mondes in Grad und Number
										objLStrich.value = correctedLengthOfTheMoon(objAverageLMoon.value, objEvectionMoon.value, objECM.value, objYe.value,  objA4.value);
										objA4.value = a4(objAverageAnomalyMoonCorrected.value);
										objAverageLMoon.value = moonAverageLengthL(objDaysSinceEpoch.value, l0_moon);
										objDaysSinceEpoch.value = calcJD(objDay.value, objMonth.value, objYear.value, 0, 0, 0, 0, 0, 0)- 
																					calcJD(0, 1, 2010, 0, 0, 0, 0, 0, 0)+  valArrUT/24.0;
										objEvectionMoon.value = correctionsForEvection(Number(objAverageAnomalyMoon.value), Number(objAverageLMoon.value),  Number(objLDSun.value));
										objLDSun.value = lambdaSun(objN.value, objEc.value, objEpsilonG.value);
										objEpsilonG.value = epsilong;
										objEc.value = calculateEc(objE.value, objMsun2.value);
										objMsun2.value = mediumSun2(objN.value, objEpsilonG.value, objOmegaG.value );
										objOmegaG.value = omegag;
										objE.value = e;
										objN.value = calculateN(objDaysSinceEpoch.value);
										objAverageAnomalyMoon.value = moonAverageAnomaly(objAverageLMoon.value, objDaysSinceEpoch.value);
										objECM.value = equationOfMiddle(objAverageAnomalyMoonCorrected.value);
										objYe.value = yearEquation(objMsun2.value);	
				
										
			nStrich				=	Der korregierte durchschnittliche Längengrad des Knotens in Grad und Number
										objNStrich.value = correctedLongitudeOfTheMoon(objAverageNMoon.value, objMsun2.value );
										objAverageNMoon.value = moonAverageLengthN(objDaysSinceEpoch.value);
			mStrichM			=	Die korregierte Anomalie des Mondes in Grad und Number
										objAverageAnomalyMoonCorrected.value = moonAverageAnomalyCorrected(objAverageAnomalyMoon.value, objEvectionMoon.value, objYe.value, objA3.value);
										objA3.value = a3(objMsun2.value);	
		
		*/
		
	}// End of if (newDay != jdDay) ...
	
	// Zu sendender String an das Hauptausgabefenster an den Aufrufer zurück
	// String to be sent to the main output window back to the caller
	return(sendString);
	
	
	
	function calcAzimuthAndAltitude(jdlt, jdMoonRise, jdMoonSet, dayRise, daySet, jdDay, jdMonth, jdYear, 
														jdHour, jdMinute, jdSecond, jdMsecond, dst, tz, longitude, glatDeg, 
														LDM, BM, averageLMoon, UT, daysSinceEpoche){
		var jdDiff = 0.0;
		console.log("jdlt =" + calcJD(jdDay, jdMonth, jdYear,  jdHour, jdMinute, jdSecond, jdMsecond, 0, 0));
		//console.log("jdMoonRiseLastDay =" + jdMoonRiseLastDay + " - date=" + julianDate2Date(jdMoonRiseLastDay) + " Time=" + percentageOfDecimal2Time(decPart(julianDate2Date(jdMoonRiseLastDay)[0]), "string"));
		//console.log("jdMoonRise =" + jdMoonRise);
		//console.log("jdMoonSet =" + jdMoonSet);
		//console.log("jdlt =" + jdlt);
		
		/*
			Die vier Fälle von Mondauf- und Untergang ind bezug auf den Tag des Datums, also
			Aufgang am nächsten Tag oder Untergang am nächsten Tag oder Taggleichheit
			
			LCTR[3](dayRise) = LCTS[3](daySet) (Tage gleich) und jdMoonSet > jdMoonRise dann ist die Diff jdMoonSet - jdMoonRise
			LCTR[3](dayRise) = LCTS[3](daySet) (Tage gleich) und jdMoonRise > jdMoonSet dann ist die Diff jdMoonRise - jdMoonSet
			LCTS[3](daySet) > LCTR[3](dayRise) (Tage verschieden) jdMoonSet > jdMoonRise dann ist die Diff jdMoonSet - jdMoonRise
			LCTR[3](dayRise) > LCTS[3](daySet) (Tage verschieden) jdMoonRise > jdMoonSet dann ist die Diff jdMoonRise - jdMoonSet
		*/
		// Am gleichen Tage Monduntergang und Mondaufgang
		// Der Mondaufgang liegt morgens vor dem Monduntergang abends.
		//
		// Liegt die aktuelle Uhrzeit vor dem Aufgang so ist der Mond unter dem Horizont
		//
		// Wenn die aktuelle Uhrzeit dazwischen liegt, steht der Mond am Himmel.
		//
		// Liegt die aktuelle Uhrzeit nach dem Untergang so ist der Mond unter dem Horizont
		if ( (LCTR[3] == LCTS[3]) && (jdMoonSet > jdMoonRise) ){
			jdDiff = jdMoonSet - jdMoonRise;
			console.log("1 Bedingung");
		// Am gleichen Tage Monduntergang und Mondaufgang
		// Der Monduntergang liegt morgens vor dem Mondaufgang abends.
		//
		// Wenn die aktuelle Uhrzeit kleiner als der Monduntergang ist, dann
		// muss die Zeit des Mondaufgangs am Tage vorher berücksichtigt werden.
		// Der Mond steht am Himmel.
		//
		// Die Zeit dazwischen ist der Mond unter dem Horizont
		//
		// Ist die aktuelle Zeit größer als der Mondaufgang so muss die Zeit ab dem
		// Mondaufgang für den Monduntergang am nächsten Tag berücksichtigt werden.
		// Der Mond steht am Himmel.
		}else if ( (LCTR[3] == LCTS[3]) && (jdMoonRise > jdMoonSet) ){
			jdDiff = jdMoonRise - jdMoonSet;
			console.log("2 Bedingung");
		// Der Tag des Monduntergang ist größer als der des Mondaufgang
		// Der Monduntergang liegt morgens vor dem nächsten Mondaufgang abends.
		//
		// Wenn die aktuelle Uhrzeit kleiner als der Monduntergang ist, dann
		// muss die Zeit des Mondaufgangs am Tage vorher berücksichtigt werden.
		// Die Zeit des Mondaufgangs ist die des aktuellen Tages.
		//
		// Ist die aktuelle Zeit größer als der Mondaufgang so muss die Zeit ab dem
		// Mondaufgang für den Monduntergang am nächsten Tag berücksichtigt werden.
		// Die Untergangszeit ist auch die des nächsten Tages.
		}else if ( (LCTS[3] > LCTR[3]) && (jdMoonSet > jdMoonRise) ){
			jdDiff = jdMoonSet - jdMoonRise;	
			console.log("3 Bedingung");
		// Der Tag des Mondaufgangs ist größer als der des Monduntergangs.
		// Der Monduntergang liegt innerhalb des Tages. Dazu gehört der
		// Mondaufgang am Vortage und der nächste Mondaufgang am Folgetage.
		//
		// Liegt die aktuelle Zeit vor dem Monduntergang, so muss die Aufgangszeit
		// vom Vortage berücksichtigt werden. Der Mond steht am Himmel.
		//
		// Liegt die aktuelle Zeit nach dem Monduntergang so ist der Mond unter dem
		// Horizont.
		}else if ( (LCTR[3] > LCTS[3]) && (jdMoonRise > jdMoonSet) ){
			jdDiff = jdMoonRise - jdMoonSet;	
			console.log("4 Bedingung");
		}else{
			alert("Keine entsprechende Mondauf- und\n\nUntergangs Konstellation gefunden!");
		}
			
		//console.log("jdDiff =" + jdDiff + " - jd Stunden=" + Number(jdDiff * 24.0) + " Time=" + percentageOfDecimal2Time(jdDiff, "string"));
		//[0]	=	Stündliche ekliptische Bewegung im  Längengrad des Mondes als dezimale 
		//			Grad und Number
		//[1]	=	Stündliche ekliptische Bewegung im Breitengrad des Mondes als dezimale 
		//			Grad und Number
		//var hmm = hourlyMotionOfTheMoon(LDM, BM, LStrich, NStrich, mStrichM);
		//console.log("hmm=" + hmm);
		// [0]		=	Neuer ekliptischer Längengrad des Mondes als dezimale Grad und Number
		// [1]		=	Neuer ekliptischer Breitengrad des Mondes als dezimale Grad und Number
		//var nmp = newMoonPosition (LDM, BM , hmm[0], hmm[1], Number(jdDiff * 24.0))
		//console.log("nmp=" + nmp);
			
		//var equRA = eclipticCoords2EquatorialRA(nmp[0], 0, 0, nmp[1], 0, 0, jdDay, jdMonth, jdYear);
		//console.log("equRA=" + equRA);
		//var equDec = eclipticCoords2EquatorialDec(nmp[0], 0, 0, nmp[1], 0, 0, jdDay, jdMonth, jdYear);
		//console.log("equDec=" + equDec);
		console.log("eclip Lambda=" + LDM);
		console.log("eclip Beta=" + BM);
		var equRA = eclipticCoords2EquatorialRA(LDM, 0, 0, BM, 0, 0, jdDay, jdMonth, jdYear);
		console.log("Function: equRA=" + equRA + " - " + decDegrees2AngleOfTime(equRA));
		var equDec = eclipticCoords2EquatorialDec(LDM, 0, 0, BM, 0, 0, jdDay, jdMonth, jdYear);
		console.log("Function: equDec=" + equDec + " - " + decDegrees2AngleOfHours(equDec));
		
		console.log("--------------------------------------------------------------------------------------------\n\n");
		
		// Als nächstes berechnen wir die rechteckigen Ekliptikkoordinaten des Mondes und rotieren sie, um rechteckige
		// Äquatorkoordinaten zu erhalten und dann RA und Decl:
		var xm2eclip = (1 * Math.cos(LDM / RAD) * Math. cos(BM / RAD)).toFixed(6);
		var ym2eclip = (1 * Math.sin(LDM / RAD) * Math.cos(BM / RAD)).toFixed(6);
		var zm2eclip = (1 * Math.sin(BM / RAD)).toFixed(6);
		console.log("Transformation: xm2eclip= " + xm2eclip + " ym2eclip=" + ym2eclip + " zm2eclip=" + zm2eclip);
		var oblecl = eclipticObliquity(jdDay, jdMonth, jdYear);
		// Rotieren in rechtwinkelige Äquatoriale Koordinaten
		var xm2equat = xm2eclip;
		var ym2equat = (ym2eclip * Math.cos(oblecl / RAD) - zm2eclip * Math.sin(oblecl / RAD)).toFixed(6);
		var zm2equat = (ym2eclip * Math.sin(oblecl / RAD) + zm2eclip * Math.cos(oblecl / RAD)).toFixed(6);
		console.log("Transformation: xm2equat= " + xm2equat + " ym2equat=" + ym2equat + " zm2equat=" + zm2equat);
		// Und dann geozentrische RA und Dec berechnen
		var geoRA   = Math.atan2( ym2equat, xm2equat );
		geoRA = unwindDeg(geoRA * RAD).toFixed(4);
		var geoDecl = ((Math.atan2( zm2equat, Math.sqrt( xm2equat*xm2equat + ym2equat*ym2equat ) )) * RAD).toFixed(4);
		console.log("Transformation: geozentr. RA= " + geoRA + " geozentr. Dec=" + geoDecl  + "\n\n");
		
		console.log("--------------------------------------------------------------------------------------------\n\n");
		
		//var horAZAlt = convertEquatorial2Horizontal(geoRA / 15.0, geoDecl, glatDeg);
		//console.log("horAZAlt=" + horAZAlt);
		//var horAZ = convertEquatorial2HorizontalAZ(equRA , equDec, glatDeg);
		//console.log("horAZ=" +  horAZ + " - " + decDegrees2AngleOfHours(horAZ ));
		
		//var horAlt = convertEquatorial2HorizontalAlt(equRA , equDec, glatDeg);
		//console.log("horAlt=" +  horAlt + " - " + decDegrees2AngleOfHours(horAlt));
			
		console.log("--------------------------------------------------------------------------------------------\n\n");
		
	}// End of calcAzimuthAndAltutude()
	
	
	
	/*	*********************************************************************************************
	Die Funktion berechnet den ekliptischen Längengrad (Lamda)der Sonne. der
	ekliptische Breitengrad der Sonne ist ja 0.0, da sie in der Ekliptik liegt.
	
	Quelle:
	https://de.wikipedia.org/wiki/Astronomische_Koordinatensysteme
	
	Übergabewert:
	N														= 	Aktuell berechnete Position in Grad 0° - 360°
																als Number
	ec														= 	Korrekturwert
	epsilong											=	Die mittlere eklipt. Längengrad der Sonne

	
	Rückgabewert:
	Ekliptischer Längengrad Sonne		= 	Als aktuelle Position in Grad bei kreisförmigem Orbit
																0° - 360°
	----------------------------------------------------------------------------------------------------------
	The function calculates the ecliptic longitude (Lamda) of the sun. the ecliptic 
	latitude of the sun is 0. 0, since it lies in the ecliptic. 
	
	Source: https://de. wikipedia. org/wiki/Astronomische_Koordinatensysteme 
	
	Transfer value: 
	N 														= Current calculated position in degrees 0° - 360° as Number 
	ec 													= Correction value 
	epsilong 											= The mean eklipt. Longitude of the sun 
	
	Return value: 
	Ecliptic longitude of the sun 			= As current position in degrees for circular orbit 0° - 360
	******************************************************************************************* */
	function lambdaSun(n, ec, epsilong){
		var N = Number(n);								// Unkorregierte mittlere Anomalie der Sonne in Grad
		var EC = Number(ec);							// Korrekturwert
		var EPSILONG = Number(epsilong);	// Die mittlere eklipt. Länge der Sonne
		var ldsun = 0.0;									// Ekliptischer Längengrad der Sonne als Ergebnis
		// Übergabewerte aufaddieren ...
		ldsun = N + EC + EPSILONG;
		// Das Ergebnis in den Bereich 0° - 360° bringen ...
		ldsun = unwindDeg(ldsun );
		// ... und zurück an den Caller.
		return(ldsun);
		
	}// End of lambdaSun()
	
}// End of moonParameters()

