/*
	Berechnung der Mondparameter zur Berechnung der Mondposition und
	weitere Daten wie größe am Himmel und Entfernung und Phase.
*/

function moonParameters(jdlt, dst, tz, latitude, sendString){
	var JDLT	=	Number(jdlt);		// Julianisches Datum der Berechnung mit TZ=0 und DST=0,
													// also UT in Greenwich
													// Julian date of calculation with TZ=0 and DST=0,
													// also UT in Greenwich
	var daysSinceEpoch = 0.0;		// Anzahl der Tage von der letzten Epoche bis zum aktuellen Datum
													// Number of days from last epoch to current date
	var CENTURY = [];					// Array für den dezimalen Anteil des vergangenen Jahrhunderts
													// Array for the decimal fraction of the past century
	var jdDate = [];						// Array für die einzelnen Datumsdaten des JD  
	var jdTime = [];						// Array für die einzelnen Uhrzeiten des JD  
	var jdDay = 0;							// Datumsdaten aus dem JD des Berechnungsdatums
	var jdMonth = 0;						// Date data from the JD of the calculation date
	var jdYear = 0;
	var jdHour = 0;
	var jdMinute = 0;
	var jdSecond = 0;
	var jdMsecond = 0;
	// Aus dem JD des Berechnungsdatums die einzelnen Datums Daten errechnen,
	// indem das JD in ein Datum konvertiert wird, der Tag hat als Dezimalstellen die
	// Uhrzeit ...
	jdDate = julianDate2Date(JDLT);
	// jdDate[0] ist der Tag als Ganzzahlanteil, mit der Uhrzeit des Tages als Nachkommaanteil ...
	jdDay = parseInt(jdDate[0] - decPart(jdDate[0]));
	jdMonth = parseInt(jdDate[1]);
	jdYear = parseInt(jdDate[2]);
	//console.log("Tag =" + jdDay);
	// Aus dem JD des Berechnungsdatums die einzelnen Uhrzeit Daten errechnen,
	// indem der jdDate[0] Nachkommaanteil in Uhrzeit konvertiert wird ...
	jdTime = percentageOfDecimal2Time(decPart(jdDate[0]), "array");
	jdHour = parseInt(jdTime[0]);
	jdMinute = parseInt(jdTime[1]);
	jdSecond = parseInt(jdTime[2]);
	jdMsecond = parseInt(jdTime[3]);
	console.log("Tag=" + jdDay + " Monat=" + jdMonth + " Jahr=" + jdYear + " - h=" + jdHour + " m=" + jdMinute + " s=" + jdSecond + " - dst=" + dst + " - tz=" + tz);
	// Berechnung der Universal Time (UT)
	console.log("moonParameter:\n");
	var UT = localtime2UT(jdHour, jdMinute, jdSecond, dst,  tz, jdDay, jdMonth, jdYear);
	console.log("UT=" + UT);
	var gDay = localtime2GreenwichDay(jdHour, jdMinute, jdSecond, dst,  tz, jdDay, jdMonth, jdYear);
	var gMonth = localtime2GreenwichMonth(jdHour, jdMinute, jdSecond, dst,  tz, jdDay, jdMonth, jdYear);
	var gYear = localtime2GreenwichYear(jdHour, jdMinute, jdSecond, dst,  tz, jdDay, jdMonth, jdYear);
	console.log("g Tag=" + gDay + " g Monat=" + gMonth + "  g Jahr=" + gYear);
	var moonPrecPosition = precMoonPos(jdHour, jdMinute, jdSecond, 0, jdDay, jdMonth, jdYear, dst, tz);
	var moonEquRA = moonPrecPosition[0];
	var moonEquDec = moonPrecPosition[1];
	var moonEclipLong = moonPrecPosition[2];
	var moonEclipLat = moonPrecPosition[3];

	var epsilonSun = calcObliquityEcliptic(jdlt);
	console.log("Eklip. Schiefe =" + epsilonSun);
	
	console.log("precMoonPos eclip long=" + moonEclipLong + " precMoonPos eclip lat=" + moonEclipLat);
	/*
	equRaDec = [];
	equRaDec.push( eclipticCoords2EquatorialRA(moonEclipLong, 0, 0,moonEclipLat, 0, 0, jdDay, jdMonth, jdYear, epsilonSun));
	equRaDec.push( eclipticCoords2EquatorialDec(moonEclipLong, 0, 0, moonEclipLat, 0, 0, jdDay, jdMonth, jdYear, epsilonSun));
	
	console.log("precMoonPos eclip long=" + moonEclipLong + " precMoonPos eclip lat=" + moonEclipLat);
	console.log("precMoonPos equ RA=" + moonEquRA + " precMoonPos equ Dec=" + moonEquDec );
	console.log("eqRA RA=" + equRaDec[0] + " eqDec Deg=" + equRaDec[1] );
	
	console.log("Horizontale AZ=" + convertEquatorial2HorizontalAZ(Number(moonEquRA), Number(moonEquDec), latitude));
	console.log("Horizontale Hoehe=" + (convertEquatorial2HorizontalAlt(Number(moonEquRA), Number(moonEquDec), latitude)));
	*/
	// Zu sendender String an das Hauptausgabefenster an den Aufrufer zurück
	// String to be sent to the main output window back to the caller
	return(sendString);
	
}// End of moonParameters()

