/* **********************************************************************************************************
 *	Das Modul beinhaltet einige Funktionen die hilfreiche Aufgaben erledigen knnen.
 * The module contains some functions that can perform helpful tasks.
 *
 *	Funktionsliste - Function list:
 *
 * - riseLocalSiderealDegreesAZ()						-	Berechnet den Azimut des Mondaufgangs in dezimalen Grad
 *																			Calculates the azimuth of the moon rise in decimal degrees
 * - setLocalSiderealDegreesAZ()						-	Berechnet den Azimut des Monduntergangs in dezimalen Grad
 *																			Calculates the azimuth of the moon set in decimal degrees
 * - riseLocalSiderealTimeAZ()							-	Berechnet die Zeit des Mondaufgangs in dezimalen Stunden
 *																			Calculates the time of the moon rise in decimal hours
 * - testTimezoneAndLongitude()						-	Testet die Zeitzone mit dem Lngengrad auf Plausibilitt
 *																		-	Tests the time zone with the longitude for plausibility
 * - objectHeight()												-	Berechnet die Objekthhe bei Auf- und Untergngen
 *																		-	Calculates the object height for ups and downs
 * - adjustUTDay()												-	Justiert die UT eventuell auf einen Tag vorher oder spter
 *																		-	Adjusts the UT possibly to a day before or later
 * - errorGreenwichST2UT()								-	Fehlerberechnung GST zu UT
 *																		-	Calculate an error by converting GST to UT
 * - greenwichST2UT()										-	Konvertiert GST zu lokaler Greenwich UT
 *																		-	Converts GST to local Greenwich UT
 * - lokalST2GreenwichST()								-	Konvertiert lokale Sternzeit zu Greenwich Sternzeit
 *																		-	Convert local sidereal time to Greenwich sidereal
 * - ut2GreenwichST()										-	Konvertiert UT zu Greenwich Sternzeit
 *																		-	Converts UT to Greenwich Star time
 * - visibleStateMoonRiseSet()							-	Ermittelt, die Sichtbarkeit des Mondes
 *																		-	Determined the visibility of the moon
 * - riseLocalSiderealTime()								-	Berechnet die Sternzeit des Aufgangs
 *																		-	Calculates the siderial time of the rise
 * - setLocalSiderealTime()								-	Berechnet die Sternzeit des Untergangs
 *																		-	Calculates the siderial time of the set
 * - startGeoPosition()										-	Ermittelt die Geodaten des PC, Startfunktion
 *																		-	Determines the spatial data of the PC, start function
 *	- getGeoPosition()										-	Callback von startGeoPosition()und ermittelt die
 *																			Daten. Nicht aufrufen.
 * 																			Callback from startGeoPosition()and determines the * data. 
 *																			Do not call.
 * - getGeoPositionError()									-	Callback von startGeoPosition()und ermittelt die
 *																			Fehler. Nicht aufrufen.
 *																			Callback from startGeoPosition()and determines the 
 * 																			errors. Do not call.
 * - getTZ()														-	Ermittelt die Zeitzone
 *																			Determines the time zone
 * - lInt()															-	Liefer vorzeichenrichtige Ganzahl einer Gleitkommazahl (Aubrunden)
 *																			Delivery precursor correct number of a floating-point number
 *	- iInt()															-	Liefer vorzeichenrichtige Ganzahl einer Gleitkommazahl (Aufrunden)
 *																			Delivery precursor correct number of a floating-point number
 * - decPart()													-	Ermittelt den Nachkommaanteil einer Dezimalzahl
 *																			Determines the fractional portion of a decimal number
 * - unwindRad()												-	Wie unwindDeg(), nur mit Radiant 57, ......
 *																			Like unwindDeg(), but with Radiant 57, . . . . . .
 * - unwindDeg()												-	Bringt eklip. Grade > 360 < -360 in den Bereich
 *																			Brings eklip. degrees > 360 < -360 in the range
 * - eclipticCoords2EquatorialDec()					-	Konvertiert ekliptische Koordinaten zur Dec
 *																			Converts ecliptic coordinates to
 * - nutationObliquity()										-	Berechnet die Schiefe der Nutation
 *																		-	Calculates the slant of the nutation
 * - eclipticObliquity()										-	Berechnet die ekliptische Schiefe
 *																		-	Calculates the ecliptic slant
 * - eclipticCoords2EquatorialRA()					-	Konvertiert ekliptische Koordinaten zur RA
 *																			Converts ecliptic coordinates to RA
 * - equatorial2EclipticLat()								-	Berechnet aus quatorial Koordinaten RA + Dec +
 *																			Greenwich Datum den Breitengrad
 *																			Calculated from equatorial coordinates RA + Dec +
 *																			Greenwich  Date the latitude
 * - equatorial2EclipticLong()							-	Berechnet aus quatorial Koordinaten RA + Dec +
 *																			Greenwich Datum den Lngengrad
 *																			Calculated from equatorial coordinates RA + Dec +
 *																			Greenwich  Date the longitude
 * - ra2HourAngle()											-	Konvertiert die quatoriale RA in Stundenwinkel
 *																			Converts the equatorial RA to hour angles
 * - angleHours2RA()										-	Konvertiert Stundenwinkel der RA in dezimale RA
 *																			Converts hour angle of RA in decimal RA
 * - parallaxDec()												-	Berechnet die korregierte Parallaxe der quatorialen Deklination
 *																			Calculates the corrected parallax of the equatorial declination
 * - parallaxHA()												-	Berechnet die korregierte Parallaxe der quatorialen RA
 *																			Calculates the corrected parallax of the equatorial RA
 * - decDegMinSec2decDeg()							-	Ekliptische Koordinaten als Stunde, Minute,
 *																			Sekunde zu dezimalen Grad konvertieren.
 *																			Ecliptic coordinates as hour, minute,
 * 																			Convert seconds to decimal degrees.
 * - deg2Radians()											-	Konvertier Gradzahl in Radianten
 *																			Konvertier-Gradzahl in Radianten
 * - anotherArcTan()											-	Ein etwas anderer Arcus Tangens
 *																			A little different Arcus Tangens
 *	- openNew()													-	ffnet ein neues Popup Fenster
 *																			Opens a new popup window
 * -  isDST ()														-	Sommer/Winterzeit ermitteln
 *																			Determine summer/winter time
 * - frac()															-	Ermittelt den Nachkommaanteil einer Dezimalzahl
 *																			Determines the decimal fraction of a decimal number
 *	- copyText2Clipboard()									- 	Kopiert den Text eines Textfeldes in die Zwischenablage
 *																			Copies the text of a text field to the clipboard
 *	- getNearestDivisor()										-	Ermittelt den Divisor eines Dividenden bei ganzzahliger Teilung
 *																			Determines the divisor of a dividend with an integer split
 *	- getDecimalPoints()										-	Ermittelt die Parameter einer Dezimalzahl, Ganzzahl, Nachkomma, Stellen
 *																			Determines the parameters of a decimal number, integer, decimal, digits
 *	- getArrRecord()											-	Sucht eine Zeile in einem assoziativen Array nach einem Wert einer Spalte
 *																			Searches for a row in an associative array for a value of a column
 *
 *
 *	Erstellt:			22.11.2020				Dieter Steffan
 *	Update			11.06.2021				Funktion copyText2Clipboard()	 hinzugefgt
 *	Update			14.07.2021				Doku equatorial2EclipticLong() + equatorial2EclipticLat() hinzugefgt
 *	Update			23.09.2021				Funktionen getNearestDivisor()	 +  getDecimalPoints() hinzugefgt
 *
 *
 ****************************************************************************************************************/

 // Hilfsvariablen
// Auxiliary variable
 
// Die Funktionen sin(), cos() ... bentigen die Werte in Radiant, also
// Radiant = Wert / RAD
//
// The functions sin () cos ()... need the values in radiant, i.e.
// Radian = Value / RAD
//
// Die Funktionen asin(), acos() ... bentigt die Werte dimensionslos.
// Das Ergebnis ist in Radiant und mu mit RAD multipliziert werden
//	Grad = Wert * RAD
// The functions asin () acos ()... need the values dimensionless, i.e.
// After that you must multiple the resolution Value with RAD
// Degrees = Value * RAD
//
var RAD = 180.0 / Math.PI;



function arrayBufferToBase64( buffer ) {
	var binary = '';
	var bytes = new Uint8Array( buffer );
	var len = bytes.byteLength;
	for (var i = 0; i < len; i++) {
		binary += String.fromCharCode( bytes[ i ] );
	}
	return btoa( binary );
	
}// End of arrayBufferToBase64()
	

function base64ToArrayBuffer(base64) {
		var binary_string =  atob(base64);
		var len = binary_string.length;
		var bytes = new Uint8Array( len );
		for (var i = 0; i < len; i++)        {
			bytes[i] = binary_string.charCodeAt(i);
		}
		return bytes.buffer;
		
}// End of base64ToArrayBuffer()




/* ***********************************************************************************************
	Die Funktion sucht aus einem assoziativen Array der Form:
						
	var arrValues = {
	"longitude": [],
	"latitude": [],
	"magnitude": []
	}
						
	fr einen Wert = value in einer benannten Spalte = key, wenn der Wert gefunden wird,
	alle Werte der Zeile im Array arr. DER GESUCHTE WERT MUSS EXAKT STIMMEN.
					
	Ergebnis=getArrRecord(arrValues, "longitude", 22.35)
						
	Der Aufruf weist der Zeichekette Ergebnis, wenn der Wert 22.35 in der Spalte "longitude",
	des benannten Arrays arrValues gefunden wird eine Zeichenkette
						
	Ergebnis=longitude=22.35~latitude=-34~magnitude=56
						
	zu. Es handelt sich immer um key=value Wertepaare. Diese werden getrennt durch die Tilde
	"~".
	Wenn nicht gefunden wird, ist der Returnwert = "" leer. Gibt es in der Spalte "longitude" mehrer
	Werte = 22.35, wird die erste Zeile zurckgegeben.

	bergabewerte:
	---------------------
		arr		=	Referenz auf das benannte Array
		key		=	Der Schlssel = Name der benannten S	palte
		value	=	Der Wert der in der Spalte gefunden werden soll
						
	Returnwerte:
	-----------------
		ret		=	Zeichenkette mit den Wertepaaren key=value~key=value ..... der Zeile
					=	Leere Zeichkette, wenn nichts gefunden wird
	-------------------------------------------------------------------------------------------------------------------
	The function searches from an associative array of the form:
						
	var arrValues = {
	longitude means [],
	latitude means [],
	magnitude means []
	}
						
	for a value = value in a named column = key if the value is found,
	all values of the row in the array arr. THE SURCHED VALUE MUST BE EXACTIVE.
					
	Result=getArrRecord (arrValues, longitude, 22.35) 
						
	The call assigns the string Result if the value 22.35 in the column longitude,
	of the named array arrValues a string is found
						
	Result=longitude=22.35~latitude=-34~magnitude=56
						
	close. These are always key=value value pairs. These are separated by the tilde
	"~".
	If not found, the return value =  is empty. In the column longitude there are more than one
	Values = 22.35, the first line is returned.

	Transfer values:
	---------------------
		arr  		= Reference to named array
		key  		= The key = Name of the named S palte
		value 	= The value to be found in the column
						
	Return values:
	-----------------
		ret  		= string with the value pairs key=value~key=value ..... of the line
					= Empty string if nothing is found
 * ***********************************************************************************************/
function getArrRecord(arr, key, value){
	var ret = "";			// Ergebnisstring - Result string
	var i;					// Zhlvariable - Counting variable
	var k;					// Bennate Spalten . Named colums
	var found = -1;		// Gefundener Index - Found index
	// Fr alle benannten Spalten = k durchlaufe das assoziative Array = arr ...
	// For all named columns = k run through the associative array = arr ...
	for (k in arr){
		// ... der Wert=value wurde in der benannten Spalte = key noch nicht gefunden ...
		// ... the value=value was not found in the named column = key ...			
		if ( found == -1){
			// ... und durchlaufe innerhalb der benannten Spalte = k (key) alle Werte ...
			// ... and pass through all values within the named column = k (key) ...
			for(i = 0; i < arr[k].length; i++){
				// ... und wenn der key = k und der Wert = value und found = -1 ist, dann ...
				// ... und wenn der key = k und der Wert = value und found = -1 ist, dann ...
				if ( ( k == key) && (value == arr[k][i]) && (found == -1) ){
					// ... hnge an den String ret den benannten Spaltenname + "=" + den Wert an ...
					// ... attach to the string ret the named column name + = + the value to ...
					ret += k + "=" + arr[k][i];
					// ... und setze die Variable found auf den Index der gefundenen Zeile, damit
					// als nchstes alle Werte und Schlssel des Arrays in die Ergebniszeichekette
					// gesetzt werden knnen ...
					// ... and set the variable found to the index of the found line so that
					// next all values and keys of the array in the result string
					// can be set ...
					found = i;
				}
			}// End for()
			// ... am Ende der Ergebniszeichenkette den Key/Value Trenner einfgen ...
			// ... insert the Key/Value separator at the end of the result string ...
			ret += "~";
		// ... der Wert=value wurde in der benannten Spalte = key gefunden ...
		// ... the value=value was found in the named column = key ...
		}else{
			// ... und durchlaufe innerhalb der benannten Spalte = k (key) alle Werte ...
			// ... and pass through all values within the named column = k (key) ...
			for(i = 0; i < arr[k].length; i++){
				// ... und wenn die Zeile = i gefunden wird, dann key und "=" und Wert an die Ergebniszeichekette anhngen ...
				// ... and if the row 0 i is found, then append key and = and value to the result string ...
				if (i == found){
					ret += k + "=" + arr[k][i];
				}
			}// End for()
			// ... am Ende der Ergebniszeichenkette den Key/Value Trenner einfgen ...
			// ... insert the Key/Value separator at the end of the result string ...
			ret += "~";
		}
	}// End for(in)
	// ... und noch letztes Zeichen = "~" aus der Zeichenkette entfernen ...
	// ... and remove the last character = ~ from the string ...
	if ( found != -1)
		ret = ret.substring(0, ret.length - 1);
	// ... und wenn nichts gefunden wird die vorhandenen "~" lschen ...
	// ... and if nothing is found delete the existing ~ ...
	else
		ret = "";
	// ... und Ergebnis zurck zum Aufrufer
	// ... and result back to the caller
	return(ret);
						
}// End of getArrRecord()




/* *********************************************************************************
	Die Funktion ermittelt den Divisor eines Dividenden, wobei die Division ohne
	Rest erfolgen muss. In diesem Fall ist das Ergebnis gefunden. Es erfolgt
	eine Wiederholung der Rechnung, bis ein entsprechender Teiler ohne Rest
	gefunden wird.
	
	bergabewert:
	-------------------
		dividend		=	Der Divident als Dezimalzahl und Number
		num				=	Der Nachkommaanteil z.B. "0.785" als String
		countnum		=	Anzahl der Nachkommastellen als Zahl und Number
		intnumber		=	Vorkommaanteil als Zahl und Integer/Number
						
	Returnwert:
	----------------
		DIVISOR		= Die Zahl, die ohne Rest durch den Dividenden geteilt 
								werden kann.
---------------------------------------------------------------------------------------------------
	The function determines the divisor of a dividend, where the division without
	The rest must be done.  In this case, the result is found.  It shall be
	a repetition of the invoice, until a corresponding divisor without remainder
	is found.
						
		Transfer value:
		-------------------
			dividend		 =	 The Divident as Decimal Number and Number
			num				 =	 The decimal part e.g.  0.785 as string
			countnum		 =	 Number of decimal digitals as number and number
			intnumber		 =	 Occurrence share as number and integer/number
					
		Return value:
		----------------
			DIVISOR		 = The number divided without remainder by the dividend 
									can be done.
*************************************************************************************** */
function getNearestDivisor(dividend, num, countnum, intnumber){
	// Der Divident / Divisor muss 0 ergeben, dann ist das Ergebnia gefunden
	//  The divident / divisor must be 0, then the result is found
	var DIVIDEND = Number(dividend);
	// Der Teiler
	// The divisor
	var DIVISOR = 0.0;
	// Der gesicherte Teiler
	//  The saved divisor
	var SAVEDIVISOR = 0.0;
	// Anzahl der Nachkommastellen ohne "0." also die reine Anzahl der Ziiffern
	// Anzahl der Nachkommastellen ohne "0." also die reine Anzahl der Ziiffern
	var STRDECPOINTS = Number(countnum);
	// String des Nachkommaanteils mit "0."
	// String of the decimal part with 0.
	var STRNUM = String(num);
	// Vorkommaanteil (Ganzzahl) der Dezimalzahl, kann 0 sein
	// Precursor fraction (integer) of the decimal number, can be 0
	var INTNUM = Number(intnumber);
	// Die Dezimale Position des Nachkommaexponenten, also z.B. -2 = 0.01
	//  The decimal position of the decimal exponent,  So e.g. -2 = 0.01
	var decExpoPart = 0.0;
	// Zhlvariable fr die letzte Position des negativen Exponenten im String
	// Zhlvariable fr die letzte Position des negativen Exponenten im String
	var i = 0;	
	// Der Divisor setzt sich zusammen aus der Ganzzahl und dem Nachkommaanteil.
	//  The divisor is composed of the integer and the decimal part
	DIVISOR = INTNUM + Number(STRNUM);
	// ... der dann gleich gespeichert wird, um wieder verwendet zu werden, wenn ntig ...
	// ... which is then immediately saved to be used again if necessary
	SAVEDIVISOR = DIVISOR;
	// ... und nun die letzte Nachkommastelle als Position als bei 0.75 ist das die 2 + 1 ...
	// ...  And now the last decimal place as a position at 0.75 is the 2 + 1.
	i = STRDECPOINTS + 1;
	// ... aber arbeite nur, wenn die Nachkommastelle nicht "0" ist ...
	// ...  but work only if the decimal place is not 0.
	if (STRNUM[i] != "0"){
		// ... und ermittle zuerst den negativen Exponenten ( z.B. 0.01) der letzten Nachkommastelle 
		// immer zur Basis 10 ....
		// ...  and first find the negative exponent (e.g. 0.01) of the last decimal place 
		//  always at the base  10 ....
		decExpoPart = (Math.pow(10, (-1 * (i - 1)))).toFixed(i - 1);
		// ... wiederhole dann solange wie der Divisor grer 0 ist und kleiner dem Dividenden ...
		//  ... then repeat as long as the divisor is greater than 0 and smaller than the dividend ..
		while( (DIVISOR > 0.0) && (DIVISOR <= DIVIDEND) ){
			// ... und ist der Divisor ohne Rest teilbar hat man den Wert gefunden und beende die Berechnung ...
			// ...  and if the divisor is divisible without remainder you have found the value and finish the calculation ...
			if ( (DIVIDEND % DIVISOR) == 0.0 )
				break;
			// ... ansonsten erniedrige den Wert um des letzten Exponentenwert ( z.B. 0.01) ...
			//  ... otherwise lower the value by the last exponent value (e.g. 0.01).
			DIVISOR -= decExpoPart;
			// ... und runde den Wert auf die Nachkommastelle 1,2,3,4 ..... ...
			// ...  and round the value to the decimal place  1,2,3,4 .....
			DIVISOR = DIVISOR.toFixed(i-1);
			// und wenn der Divisor bei 0 ist, dann erhhe den Divisor wieder mit dem alten Wert +
			// dessen Hlfte und versuche erneut einen wert zu finden ...
			// and if the divisor is 0 then increase the divisor again with the old value +
			//  half of it and try again to find one worth ...
			if (DIVISOR ==  0.0) {
				DIVISOR = SAVEDIVISOR +  (SAVEDIVISOR / 2.0);
				// ... sichere den neuen Wert gleich wieder ...
				//  ... save the new value right away ...
				SAVEDIVISOR = DIVISOR;
			}
		}// End of while()
	}
	// ... und berechneten Wert an den Aufrufer zurck ...
	// ... and calculated value back to the caller ...
	return(DIVISOR);
					
}// End of getNearestDivisor()



					
/* *********************************************************************************
	Die Funktion bestimmt den Wert der Nachkommazahl, der Ganzzahl und 
	die Anzahl der Stellen nach dem Komma.
						
	bergabewert:
		num			=	Die dezimalzahl als Number
						
	Returnwert:
		RES[0]		=	Die Nachkommazahl, z.B. 0.75, als Number
		RES[1]		=	Die Anzahl der Nachkommastellen als Integer/Number
		RES[2]		=	Der ganzzahlige Anteil der Dezimalzahl num
---------------------------------------------------------------------------------------------------
	The function determines the value of the decimal number, the integer and 
	the number of digits after a comma.
					
	Transfer value:
		num			 =	 The decimal number as number
						
	Return value:
		RES[0]		 =	 The decimal number, e.g. 0.75, as number
		RES[1]		 =	 The number of decimal points as integer/number
		RES[2]		 =	 The integer portion of the decimal  num
*************************************************************************************** */
function getDecimalPoints(num){
	// Der bergebene Zahlenwert als String
	//  The passed numerical value as string
	var STRNUM = String(num);
	// Die gesamte Anzahl der Nachkommastellen, inklusive "0." 
	//  The total number of decimal points, including 0.
	var STRDECPOINTS = String(frac(STRNUM)).length;
	// Die dezimale Zahl des Nachkommawertes
	//  The decimal number of the decimal value
	var DECPOINTSVALUE = frac(Number(STRNUM));
	// Den Wert der Nachkommastellen und die Anzahl der Nachkommastellen
	//  The value of the decimal places and the number of decimal places
	RES = new Array();
	// Wird eine Ganzzahl bergeben z.B 45, dann ist die Anzahl der Nachkommastellen = 1,
	// nmlich 0 ...
	// Wird eine Dezimalzahl bergeben z.B. 45.1, dann ist die Anzahl der Nachkommastellen = 3,
	// nmlich 0.1 ...
	//
	//  An integer is passed  e.g B 45, then the number of decimal points is equal to 1,
	//  namely 0 ...
	// A decimal number is passed  e.g. 45.1, then the number of decimal places is equal to 3 ,
	// namely  0.1 .
	// Durchluft den String mit der dezimalen Nachkommastelle z.B. 0.34056 vom Index 0 bis
	// zum Ende - 3, dann hat man dei Anzahl der Nachkommastellen.
	//
	// Die Nachkommastellen als Zahl in Index 0
	//  The decimal points as a number in index 0
	RES.push(DECPOINTSVALUE);
	// Das Ergebnis ist die Lnge der Nachkommastellen -2 fr "0." in Index 1
	//  The result is the length of the decimal place -2 for 0. in index 1
	// Wenn die Zahl nach dem Komma 0 ist, dann auch 0 bergeben
	// If the number after the comma is 0, then pass 0
	if (DECPOINTSVALUE == 0)
		RES.push(0);
	else
		RES.push(STRDECPOINTS - 2);
	// Den ganzzahligen Anteil als Number im Index 2
	//  The integer portion as a number in Index 2
	RES.push(Number(STRNUM) - DECPOINTSVALUE);
	// Und zurck zum Aufrufer.
	// And back to the caller.
	return(RES);
						
}// End of getDecimalPoints()
					



/* *********************************************************************************
 *	Die Funktion berechnet aus den quatorialen Koordinaten der RA + Dec,
 *	und dem Greenwich Datum den ekliptischen Breitengrad in dezimalen Grad.
 *	
 *	bergabewerte:
 *		raHour									= Die Stunden der quatorialen RA (Rektaszension)
 *		raMin									= Die Minuten der quatorialen RA (Rektaszension)
 *		raSec									= Die Sekunden der quatorialen RA (Rektaszension)
 *		decDeg								= Die Grad der quatorialen Dec (Deklination)
 *		decMin									= Die Minuten der quatorialen Dec (Deklination)
 *		decSec									= Die Sekunden der quatorialen Dec (Deklination)
 *		gDay									= Greenwich Tag
 *		gMonth									= Greenwich Monat
 *		gYear									= Greenwich Jahr
 *		
 *	Returnwert:
 *		EQELAT 								= Ekliptischer Breitengrad dezimale Grad und Number.
 *	---------------------------------------------------------------------------------------------------
 *	 The function is calculated from the equatorial coordinates of RA + Dec,
 *	 and the Greenwich date the ecliptic latitude in decimal degrees.
 *	
 *	 Transfer values:
 *		 raHour									=  The Hours of Equatorial RA (Rectascension) 
 *		 raMin       							=  The Minutes of Equatorial RA (Rectascension) 
 *		 raSec									=  The Seconds of Equatorial RA (Rectascension) 
 *		 decDeg								=  The degrees of equatorial dec (declination) 
 *		 decMin								=  The Minutes of Equatorial Dec (Declination) 
 *		 decSec								=  The Seconds of Equatorial Dec (Declination) 
 *		 gDay									=  Greenwich Day
 *		 gMonth								=  Greenwich Month
 *		 gYear									=  Greenwich Year
 *		
 *	 Return value:
 *		 EQELAT 								=  Ecliptic latitude decimals degree and number.
 *************************************************************************************** */
function equatorial2EclipticLat(raHour, raMin, raSec, decDeg, decMin, decSec, gDay, gMonth, gYear){
	var RAHOUR = Number(raHour);					// Stunden der RA - Hours of RA
	var RAMIN = Number(raMin);						// Minuten der RA - Minutes of RA
	var RASEC = Number(raSec);						// Sekunden der RA - Seconds of RA
	var DECDEG = Number(decDeg);				// Deklination Grad - Degrees of declination
	var DECMIN = Number(decMin);					// Minuten der Deklination - Minutes of declination
	var DECSEC = Number(decSec);					// Sekunden der Deklination - Seconds of declination
	var GDAY = Number(gDay);							// Tag des Datums - Day of the date
	var GMONTH = Number(gMonth);				// Monat des Datums - Month of the date
	var GYEAR = Number(gYear);						// Jahr des Datums - Year of the date
	var EQELAT = 0.0;										// returnwert - Return value
	// Die quatoriale RA h, m, s in dezimale Stunden umwandeln, diese dann in
	// dezimale Grad umwandeln und nach Radiant konvertieren ...
	//  Convert the equatorial RA h, m, s into decimals hours, then into
 	//  Convert Decimal Degrees and Convert to Radiant ...
	var A =  dezHours2dezDeg(time2Dectime(RAHOUR, RAMIN, RASEC, 0)) / RAD;
	//console.log("equatorial2EclipticLong A=" + A);
	// Die quatoriale Deklination in dezimale Grad umwandeln und dann nach
	// Radiant konvertieren ...
	//  Convert the equatorial declination to decimals and then to
 	// Convert Radiant ...
	var B = decDegMinSec2decDeg(DECDEG, DECMIN, DECSEC) / RAD;
	//console.log("equatorial2EclipticLong B=" + B);
	// Die ekliptische Schiefe berechnen und in Radianten konvertieren ...
	//  Calculate the ecliptic skew and convert it to radiants ...
	var C = eclipticObliquity(GDAY, GMONTH, GYEAR) / RAD;
	// Winkelfunktionen anwenden ...
	// Apply angular functions ...
	var D = Math.sin(B) * Math.cos(C) - Math.cos(B) * Math.sin(C) * Math.sin(A);
	// Den ekliptischen Breitengrad der vorher berechneten Winkel in Grad ermitteln ...
	//  Determine the ecliptic latitude of the previously calculated angles in degrees ...
	EQELAT = Math.asin(D) * RAD;
	// Und zurck zum Aufrufer.
	// And back to the caller.
	return(EQELAT);
	
}// End of equatorial2EclipticLat()



/* *********************************************************************************
 *	Die Funktion berechnet aus den quatorialen Koordinaten der RA + Dec,
 *	und dem Greenwich Datum den ekliptischen Lngengrad in dezimalen Grad.
 *	
 *	bergabewerte:
 *		raHour									= Die Stunden der quatorialen RA (Rektaszension)
 *		raMin									= Die Minuten der quatorialen RA (Rektaszension)
 *		raSec									= Die Sekunden der quatorialen RA (Rektaszension)
 *		decDeg								= Die Grad der quatorialen Dec (Deklination)
 *		decMin									= Die Minuten der quatorialen Dec (Deklination)
 *		decSec									= Die Sekunden der quatorialen Dec (Deklination)
 *		gDay									= Greenwich Tag
 *		gMonth								= Greenwich Monat
 *		gYear									= Greenwich Jahr
 *		
 *	Returnwert:
 *		EQELAT 								= Ekliptischer Breitengrad dezimale Grad und Number.
 *	---------------------------------------------------------------------------------------------------
 *	 The function is calculated from the equatorial coordinates of RA + Dec,
 *	 and the Greenwich date the ecliptic longitude in decimal degrees.
 *	
 *	 Transfer values:
 *		 raHour									=  The Hours of Equatorial RA (Rectascension) 
 *		 raMin       							=  The Minutes of Equatorial RA (Rectascension) 
 *		 raSec									=  The Seconds of Equatorial RA (Rectascension) 
 *		 decDeg								=  The degrees of equatorial dec (declination) 
 *		 decMin								=  The Minutes of Equatorial Dec (Declination) 
 *		 decSec								=  The Seconds of Equatorial Dec (Declination) 
 *		 gDay									=  Greenwich Day
 *		 gMonth								=  Greenwich Month
 *		 gYear									=  Greenwich Year
 *		
 *	 Return value:
 *		 EQELONG 							=  Ecliptic longitude decimals degree and number.
 *************************************************************************************** */
function equatorial2EclipticLong(raHour, raMin, raSec, decDeg, decMin, decSec, gDay, gMonth, gYear){
	var RAHOUR = Number(raHour);					// Stunden der RA - Hours of RA
	var RAMIN = Number(raMin);						// Minuten der RA - Minutes of RA
	var RASEC = Number(raSec);						// Sekunden der RA - Seconds of RA
	var DECDEG = Number(decDeg);				// Deklination Grad - Degrees of declination
	var DECMIN = Number(decMin);					// Minuten der Deklination - Minutes of declination
	var DECSEC = Number(decSec);					// Sekunden der Deklination - Seconds of declination
	var GDAY = Number(gDay);							// Tag des Datums - Day of the date
	var GMONTH = Number(gMonth);				// Monat des Datums - Month of the date
	var GYEAR = Number(gYear);						// Jahr des Datums - Year of the date
	var EQELONG = 0.0;
	// Die quatoriale RA h, m, s in dezimale Stunden umwandeln, diese dann in
	// dezimale Grad umwandeln und nach Radiant konvertieren ...
	//  Convert the equatorial RA h, m, s into decimals hours, then into
 	//  Convert Decimal Degrees and Convert to Radiant ...
	var A =  dezHours2dezDeg(time2Dectime(RAHOUR, RAMIN, RASEC, 0)) / RAD;
	//console.log("equatorial2EclipticLong A=" + A);
	// Die quatoriale Deklination in dezimale Grad umwandeln und dann nach
	// Radiant konvertieren ...
	//  Convert the equatorial declination to decimals and then to
 	// Convert Radiant ...
	var B = decDegMinSec2decDeg(DECDEG, DECMIN, DECSEC) / RAD;
	//console.log("equatorial2EclipticLong B=" + B);
	// Die ekliptische Schiefe berechnen und in Radianten konvertieren ...
	//  Calculate the ecliptic skew and convert it to radiants ...
	var C = eclipticObliquity(GDAY, GMONTH, GYEAR) / RAD;
	//console.log("equatorial2EclipticLong C=" + C);
	// Winkelfunktionen anwenden ...
	// Apply angular functions ...
	var D = Math.sin(A) * Math.cos(C) + Math.tan(B) * Math.sin(C);
	//console.log("equatorial2EclipticLong D=" + D);
	var E = Math.cos(A);
	// Den ekliptischen Lngengrad der vorher berechneten Winkel in Grad ermitteln ...
	//  Determine the ecliptic longitude of the previously calculated angles in degrees ...
	var F = anotherArcTan(E, D) * RAD;
	//console.log("equatorial2EclipticLong F=" + F);
	// Den Lngengrad in den richtigen Bereich bringen ...
	//  Bring the longitude to the right range ...
	EQELONG = F - 360.0 * Math.floor(F / 360.0);
	// ... und zurck zum Aufrufer.
	// ... and back to the caller.
	return(EQELONG);
	
}// End of equatorial2EclipticLong()




/* *********************************************************************************
 *	Die Funktion berechnet die korregierte Parallaxe fr die quatorialen
 * Deklination der RA. Es werden dieselben Parameter wie bei der Funktion
 * parallaxHA verwendet.
 *	
 *	bergabewerte:
 *		raHour									= Die Stunden der quatorialen RA (Rektaszension)
 *		raMin									= Die Minuten der quatorialen RA (Rektaszension)
 *		raSec									= Die Sekunden der quatorialen RA (Rektaszension)
 *		decDeg								= Die Grad der quatorialen Dec (Deklination)
 *		decMin									= Die Minuten der quatorialen Dec (Deklination)
 *		decSec									= Die Sekunden der quatorialen Dec (Deklination)
 *		trueCoordOrApparentCoord	= Wahre oder scheinbahre Koordinaten
 *		gLat										= Breitengrad der Beobachtung in Grad
 *		height									= Hhe der Beobachtung ber dem Meeresspiegel in Metern
 *		horParallax							= Horizontale Parallaxe in Grad
 *		
 *	Returnwert:
 *		Q 										= Korregierte Parallaxe der Deklination als dezimale Zahlenwert und Number.
 *	---------------------------------------------------------------------------------------------------
 *	 The function calculates the corrected parallax for the equatorial
 *  Declination of RA.  The same parameters are used as in the function
 * parallaxHA used.
 *	
 *	 Transfer values:
 *		 raHour									=  The Hours of Equatorial RA (Rectascension) 
 *		 raMin        							=  The Minutes of Equatorial RA (Rectascension) 
 *		 raSec									=  The Seconds of Equatorial RA (Rectascension) 
 *		 decDeg								=  The degrees of equatorial dec (declination) 
 *		 decMin								=  The Minutes of Equatorial Dec (Declination) 
 *		 decSec								=  The Seconds of Equatorial Dec (Declination) 
 *		 trueCoordOrApparentCoord=  True or false coordinates
 *		 gLat									=  Latitude of observation in degrees
 *		 height         							=  Altitude of observation above sea level in metres
 *		 horParallax							=  Horizontal Parallax in Grad
 *		
 *	 Return value:
 *		 Q 										=  Corrected parallax of declination as decimal value and number.
 *************************************************************************************** */
function parallaxDec(raHour, raMin, raSec, decDeg, decMin, decSec, trueCoordOrApparentCoord, gLat, height, horParallax){
	var Q = 0.0;													// Returnwert ist die parrallaxen korregierte Deklination
																		// der quatorialen RA + Dec
																		// Return value  is the parrallax corrected declination
 																		// of the equatorial RA + Dec
	var GLAT = Number(gLat);							// Der geografische Breitengrad der Beobachtung
																		// The geographical latitude of the observation
	var HEIGHT = Number(height);						// Hhe ber dem Meeresspiegel im Metern
																		// Height above sea level in meters
	var HORPARALLAX = Number(horParallax);	// Horizontale Parallaxe
																		// Horizontal parallax
	var TRUECOORDORAPPARENTCOORD = String(trueCoordOrApparentCoord);
	var RAHOUR = Number(raHour);					// Stunden der RA - Hours of RA
	var RAMIN = Number(raMin);						// Minuten der RA - Minutes of RA
	var RASEC = Number(raSec);						// Sekunden der RA - Seconds of RA
	var DECDEG = Number(decDeg);				// Deklination Grad - Degrees of declination
	var DECMIN = Number(decMin);					// Minuten der Deklination - Minutes of declination
	var DECSEC = Number(decSec);				// Sekunden der Deklination - Seconds of declination
	var A = 0.0;													// Geografische Breite als Radiant
																		//  Geographical latitude as radiant
	var C1 = 0.0;												// Kosinus der geogr. Breite
																		// Cosine of the geogr.  Width
	var S1 = 0.0;												// Sinus der geogr. Breite
																		// Sine of the geogr. Width
	var U = 0.0;													// Der Arcus Tangens von Sinus + Cosinus der geogr. Breite
																		// The arcus tangens of sine + cosine of geogr.  Width
	var C2 = 0.0;												// Kosinus von U
																		// Cosine from U
	var S2 = 0.0;												// Sinus von U
																		// Sine from U
	var B = 0.0;													// Nimmt den Wert der Hhe ber Meerespiegel (m) / Konstante auf
																		// Takes  the value of altitude above sea level (m)   / Constant on
	var RS = 0.0;												// Winkel aus der Hhe ber Meeresspiegel
																		// Angle from height above sea level
	var RC = 0.0;												// 
	var RP = 0.0;												// Horizontale parallaktische Korrektur
																		// Horizontal  Parallactic correction
	var TP = 0.0;												// Konstante 2 x PI - // Constant  2 x PI
	var X = 0.0;													// Weitere Hilfsvariablen - Auxilary variables
	var X1 = 0.0;
	var Y = 0.0;
	var Y1 = 0.0;
	var D = 0.0;
	var P = 0.0;
	var P1 = 0.0;
	var P2 = 0.0;
	var Q1 = 0.0;
	var Q2 = 0.0;
	var AA = 0.0;
	var BB = 0.0;
	var CX = 0.0;
	var CY = 0.0;
	var SY = 0.0;
	// Geografische Breite als Radiant ...
	//  Geographical latitude as radiant ...
	A = GLAT / RAD;
	// ... und davon der Cosinus ...
	// ... and of it the cosine ...
	C1 = Math.cos(A);
	// ... und davon der Sinus ...
	// ... and of it the sine ...
	S1 = Math.sin(A);
	// ... dann den Winkel aus Sinus S1 / Cosinus C1 berechnen ...
	// ...  then calculate the angle of sine  S1 / cosine C1 ...
	U = Math.atan(0.996647 * S1 / C1);
	// ... der Kosinus von U ...
	// ... the cosine of U ...
	C2 = Math.cos(U);
	// ... der Sinus von U ...
	// ... the sine of U ...
	S2 = Math.sin(U);
	// ... nun berechnen den Anteil der Hhe ber Meer / Erdradius in Metern
	//  ... now calculate the proportion of altitude above sea / earth radius in meters
	B = HEIGHT / 6378160.0;
	RS = (0.996647 * S2) + (B * S1);
	RC = C2 + (B * C1);
	TP = 6.283185308;
	RP = 1.0 / Math.sin(HORPARALLAX / RAD);
	// ... h, m, s der Lngengrade in dezimale Stunden umrechnen und diese dann in dezimale Grade
	// umrechnen und nach Radiant konvertieren ...
	// ...  Convert h, m, s of longitude into decimals hours and then into decimals
 	//  Convert and convert to radiant ...
	X = dezHours2dezDeg(time2Dectime(RAHOUR, RAMIN, RASEC, 0)) / RAD;
	X1 = X;
	// ... Grad, m, s der Deklination in dezimale Grade umrechnen und dann nach
	// Radiant konvertieren ...
	//  ... Convert degrees, m, s of declination to decimals and then to
 	// Convert Radiant ...
    Y = decDegMinSec2decDeg(DECDEG, DECMIN, DECSEC) / RAD;
	Y1 = Y;
	// ... Bewerte die Variable "trueCoordOrApparentCoord" bei "True" oder "true" ...
	//  ... Rate the variable trueCoordOrApparentCoord with True or true ...
	if (TRUECOORDORAPPARENTCOORD[0] == "T" || TRUECOORDORAPPARENTCOORD[0] == "t") 
        D = 1.0;
	// ... und bei einem anderen Wert ...
	// ... and at a different value ...
	else
		D = -1.0;
	// ... wenn die Koordinaten "Wahr" sind, dann Unterfunktion aufrufen und danach beenden
	// und zurck zum Aufrufer.
	//  ... if the coordinates are Truth, then call subfunction and then stop
 	// and back to the caller.
	if ( D == 1){
		// ... Unterfunktion rufen ...
		// ... call function sub2870()
		sub2870();
		// ... und dann das Ergebnis zurck zum Aufrufer.
		// ...  and then the result back to the caller.
		return(Q * RAD);
	}
	P1 = 0;
	Q1 = 0;
	// ... Unterfunktion zur wiedrrholten Berechnung von Werten bis zum
	// Abbruchkriterium ...
	//  ... sub-function for repeated calculation of values up to
 	// Abort Criterion ...
	function sub2845(){
		sub2870();
		P2 = P - X;
		Q2 = Q - Y;
		AA = Math.abs(P2 - P1);
		BB = Math.abs(Q2 - Q1);
		// ... das Beenden Kriterium erreicht fr gengend Genauigkeit ? ...
		//  ...  the quit criterion reaches for sufficient accuracy ?  ...
		if ((AA < 0.000001) && (BB < 0.000001)){
			P = X1 - P2;
			Q = Y1 - Q2;
			X = X1;
			Y = Y1;
			// ... und zurck zum Aufrufer.
			// ... and back to the caller.
			return(Q * RAD);
		}
		X = X1 - P2;
		Y = Y1 - Q2;
		P1 = P2;
		Q1 = Q2;
		// ... rufe die eigene Funktion rekursiv auf ...
		//  ... call your own function recursively ...
		sub2845();
	}// End og sub2845()
	
	// Unterfunktion zu weiteren, wiederholten Berechnungen ...
	//  Subfunction for further, repeated calculations ...
	function sub2870(){
		CX = Math.cos(X);
		SY = Math.sin(Y);
		CY = Math.cos(Y);
		AA = (RC * Math.sin(X)) / ((RP * CY) - (RC * CX));
		DX = Math.atan(AA);
		P = X + DX;
		CP = Math.cos(P);
		P = P - TP * parseInt(P / TP);
		Q = Math.atan(CP * (RP * SY - RS) / (RP * CY * CX - RC));
		// ... und zurck zum Aufrufer.
		// ... and back to the caller.
		return;
	}// End of sub2870()
	
	// ... und zurck zum Aufrufer.
	// ... and back to the caller.
	return(Q * RAD);
	
}// End of parallaxDec()



/* *********************************************************************************
 *	Die Funktion berechnet die korregierte Parallaxe fr die quatorialen
 * Stundenwinkel der RA.
 *	
 *	bergabewerte:
 *		raHour									= Die Stunden der quatorialen RA (Rektaszension)
 *		raMin									= Die Minuten der quatorialen RA (Rektaszension)
 *		raSec									= Die Sekunden der quatorialen RA (Rektaszension)
 *		decDeg								= Die Grad der quatorialen Dec (Deklination)
 *		decMin									= Die Minuten der quatorialen Dec (Deklination)
 *		decSec									= Die Sekunden der quatorialen Dec (Deklination)
 *		trueCoordOrApparentCoord	= Wahre oder scheinbahre Koordinaten
 *		gLat										= Breitengrad der Beobachtung in Grad
 *		height									= Hhe der Beobachtung ber dem Meeresspiegel in Metern
 *		horParallax							= Horizontale Parallaxe in Grad
 *		
 *	Returnwert:
 *		P 											= Korregierte Parallaxe der RA als dezimale Zahlenwert und Number.
 *	---------------------------------------------------------------------------------------------------
 *	 The function calculates the corrected parallax for the equatorial
 *  Hour angle of the RA.
 *	
 *	 Transfer values:
 *		 raHour									=  The Hours of Equatorial RA (Rectascension) 
 *		 raMin        							=  The Minutes of Equatorial RA (Rectascension) 
 *		 raSec									=  The Seconds of Equatorial RA (Rectascension) 
 *		 decDeg								=  The degrees of equatorial dec (declination) 
 *		 decMin								=  The Minutes of Equatorial Dec (Declination) 
 *		 decSec								=  The Seconds of Equatorial Dec (Declination) 
 *		 trueCoordOrApparentCoord=  True or false coordinates
 *		 gLat									=  Latitude of observation in degrees
 *		 height         							=  Altitude of observation above sea level in metres
 *		 horParallax							=  Horizontal Parallax in Grad
 *		
 *	 Return value:
 *		 P 										=  Corrected parallax of RA as decimal value and number.
 *************************************************************************************** */
function parallaxHA(raHour, raMin, raSec, decDeg, decMin, decSec, trueCoordOrApparentCoord, gLat, height, horParallax){
	var P = 0.0;													// Returnwert ist der parralaxen korregierte Stundenwinkel 
																		// der quatorialen RA
	var GLAT = Number(gLat);							// Der geografische Breitengrad der Beobachtung
																		// The geographical latitude of the observation
	var HEIGHT = Number(height);					// Hhe ber dem Meeresspiegel im Metern
																		// Height above sea level in meters
	var HORPARALLAX = Number(horParallax);// Horizontale Parallaxe
																		// Horizontal parallax
	var TRUECOORDORAPPARENTCOORD = String(trueCoordOrApparentCoord);
	var RAHOUR = Number(raHour);				// Stunden der RA - Hours of RA
	var RAMIN = Number(raMin);						// Minuten der RA - Minutes of RA
	var RASEC = Number(raSec);						// Sekunden der RA - Seconds of RA
	var DECDEG = Number(decDeg);				// Deklination Grad - Degrees of declination
	var DECMIN = Number(decMin);					// Minuten der Deklination - Minutes of declination
	var DECSEC = Number(decSec);				// Sekunden der Deklination - Seconds of declination
	var A = 0.0;													// Geografische Breite als Radiant
																		//  Geographical latitude as radiant
	var C1 = 0.0;												// Kosinus der geogr. Breite
																		// Cosine of the geogr.  Width
	var S1 = 0.0;												// Sinus der geogr. Breite
																		// Sine of the geogr. Width
	var U = 0.0;													// Der Arcus Tangens von Sinus + Cosinus der geogr. Breite
																		// The arcus tangens of sine + cosine of geogr.  Width
	var C2 = 0.0;												// Kosinus von U
																		// Cosine from U
	var S2 = 0.0;												// Sinus von U
																		// Sine from U
	var B = 0.0;													// Nimmt den Wert der Hhe ber Meerespiegel (m) / Konstante auf
																		// Takes  the value of altitude above sea level (m)   / Constant on
	var RS = 0.0;												// Winkel aus der Hhe ber Meeresspiegel
																		// Angle from height above sea level
	var RC = 0.0;												// 
	var RP = 0.0;												// Horizontale parallaktische Korrektur
																		// Horizontal  Parallactic correction
	var TP = 0.0;												// Konstante 2 x PI - // Constant  2 x PI
	var X = 0.0;													// Weitere Hilfsvariablen - Auxilary variables
	var X1 = 0.0;
	var Y = 0.0;
	var Y1 = 0.0;
	var D = 0.0;
	var P = 0.0;
	var P1 = 0.0;
	var P2 = 0.0;
	var Q1 = 0.0;
	var Q2 = 0.0;
	var AA = 0.0;
	var BB = 0.0;
	var CX = 0.0;
	var CY = 0.0;
	var SY = 0.0;
	// Geografische Breite als Radiant ...
	//  Geographical latitude as radiant ...
	A = GLAT / RAD;
	// ... und davon der Cosinus ...
	// ... and of it the cosine ...
	C1 = Math.cos(A);
	// ... und davon der Sinus ...
	// ... and of it the sine ...
	S1 = Math.sin(A);
	// ... dann den Winkel aus Sinus S1 / Cosinus C1 berechnen ...
	// ...  then calculate the angle of sine  S1 / cosine C1 ...
	U = Math.atan(0.996647 * S1 / C1);
	// ... der Kosinus von U ...
	// ... the cosine of U ...
	C2 = Math.cos(U);
	// ... der Sinus von U ...
	// ... the sine of U ...
	S2 = Math.sin(U);
	// ... nun berechnen den Anteil der Hhe ber Meer / Erdradius in Metern
	//  ... now calculate the proportion of altitude above sea / earth radius in meters
	B = HEIGHT / 6378160.0;
	RS = (0.996647 * S2) + (B * S1);
	RC = C2 + (B * C1);
	TP = 6.283185308;
	RP = 1.0 / Math.sin(HORPARALLAX / RAD);
	// ... h, m, s der Lngengrade in dezimale Stunden umrechnen und diese dann in dezimale Grade
	// umrechnen und nach Radiant konvertieren ...
	// ...  Convert h, m, s of longitude into decimals hours and then into decimals
 	//  Convert and convert to radiant ...
	X = dezHours2dezDeg(time2Dectime(RAHOUR, RAMIN, RASEC, 0)) / RAD;
	X1 = X;
	// ... Grad, m, s der Deklination in dezimale Grade umrechnen und dann nach
	// Radiant konvertieren ...
	//  ... Convert degrees, m, s of declination to decimals and then to
 	// Convert Radiant ...
    Y = decDegMinSec2decDeg(DECDEG, DECMIN, DECSEC) / RAD;
	Y1 = Y;
	// ... Bewerte die Variable "trueCoordOrApparentCoord" bei "True" oder "true" ...
	//  ... Rate the variable trueCoordOrApparentCoord with True or true ...
	if (TRUECOORDORAPPARENTCOORD[0] == "T" || TRUECOORDORAPPARENTCOORD[0] == "t") 
        D = 1.0;
	// ... und bei einem anderen Wert ...
	// ... and at a different value ...
	else
		D = -1.0;
	//console.log("parallaxHA D=" + D);
	// ... wenn die Koordinaten "Wahr" sind, dann Unterfunktion aufrufen und danach beenden
	// und zurck zum Aufrufer.
	//  ... if the coordinates are Truth, then call subfunction and then stop
 	// and back to the caller.
	if ( D == 1){
		// ... Unterfunktion rufen ...
		// ... call function sub2870()
		sub2870();
		// ... und dann das Ergebnis zurck zum Aufrufer.
		// ...  and then the result back to the caller.
		return(dezDegs2dezHours(P * RAD));
	}
	P1 = 0;
	Q1 = 0;
	// ... Unterfunktion zur wiederholten Berechnung von Werten bis zum
	// Abbruchkriterium ...
	//  ... sub-function for repeated calculation of values up to
 	// Abort Criterion ...
	function sub2845(){
		sub2870();
		P2 = P - X;
		Q2 = Q - Y;
		AA = Math.abs(P2 - P1);
		BB = Math.abs(Q2 - Q1);
		// ... das Beendenkriterium erreicht fr gengend Genauigkeit ? ...
		//  ...  the quit criterion reaches for sufficient accuracy ?  ...
		if ((AA < 0.000001) && (BB < 0.000001)){
			P = X1 - P2;
			Q = Y1 - Q2;
			X = X1;
			Y = Y1;
			// ... und zurck zum Aufrufer.
			// ... and back to the caller.
			return(dezDegs2dezHours(P * RAD));
		}
		X = X1 - P2;
		Y = Y1 - Q2;
		P1 = P2;
		Q1 = Q2;
		// ... rufe die eigene Funktion rekursiv auf ...
		//  ... call your own function recursively ...
		sub2845();
	}// End og sub2845()
	
	// Unterfunktion zu weiteren, wiederholten Berechnungen ...
	//  Subfunction for further, repeated calculations ...
	function sub2870(){
		CX = Math.cos(X);
		SY = Math.sin(Y);
		CY = Math.cos(Y);
		AA = (RC * Math.sin(X)) / ((RP * CY) - (RC * CX));
		DX = Math.atan(AA);
		P = X + DX;
		CP = Math.cos(P);
		P = P - TP * parseInt(P / TP);
		Q = Math.atan(CP * (RP * SY - RS) / (RP * CY * CX - RC));
		// ... und zurck zum Aufrufer.
		// ... and back to the caller.
		return;
	}// End of sub2870()
	
	// ... und zurck zum Aufrufer.
	// ... and back to the caller.
	return(dezDegs2dezHours(P * RAD));
	
}// End of parallaxHA()



/* *********************************************************************************
 *	Die Funktion konvertier die Universalzeit (UT = Universal Time) in die
 * GST = Greenwich Star Time. Dazu wird die lokale Uhrzeit, die Sommer/
 * Winterzeit und der Zeitzonen Offset, wie auch das Datum verwendet.
 *	
 *	bergabewerte:
 *		lctHour			= Lokale Stunde, kann hier auch die dezimale Zeit sein
 *		lctMin			= Lokale Minute oder 0, wenn Stunde Dezimalwert ist
 *		lctSec			= Lokale Sekunde oder 0, wenn Stunde Dezimalwert ist
 *		dst				= Sommer/Winterzeit 0/1
 *		tz					= Zeitzone  -12 <= tz <= 12
 *		IDay				= Lokaler Greenwich Tag der Berechnung
 *		IMonth			= Lokaler Greenwich Monat der Berechnung	
 *		IYear			= Lokales Greenwich Jahr der Berechnung
 *		
 *	Returnwert:
 *		GST als dezimale Zahlenwert und Number.
 *	---------------------------------------------------------------------------------------------------
 *	 The function converts the universal time (UT =  Universal Time) in the
 *  GST  =  Greenwich Star Time.  The local time, the summer/
 *  Winter time and the time zones offset, as well as the date used.
 *	
 *	 Transfer values:
 *		 lctHour		=  Local hour, here may also be the decimal time
 *		 lctMin			=  Local minute or 0 if hour is decimal
 *		 lctSec			=  Local second or 0 if hour is decimal
 *		 dst				=  Summer /Winter time  0/1
 *		 tz				=  Time zone   -12 < =  tz < =  12
 *		 IDay			=  Local  Greenwich day of calculation
 *		 IMonth		= 	Local  Greenwich Month of Calculation	
 *		 IYear			=  Local  Greenwich  Year of calculation
 *		
 *	 Return value:
 *		 GST as decimal numerical value and number.
  *************************************************************************************** */
function ut2GreenwichST(lctHour, lctMin, lctSec, dst, tz, IDay, IMonth, IYear){
	var LCTHOUR = Number(lctHour);	// Stunden der lokalen Zeit - Hours of local time
	var LCTMIN = Number(lctMin);		// Minuten der lokalen Zeit - Minutes of local time
	var LCTSEC = Number(lctSec);		// Sekunden der lokalen Zeit - Seconds of local time
	var DST = Number(dst);					// Sommer/Winterzeit - Daylight savin time offset
	var TZ = Number(tz);						// Zeitzonen Offset - Time zone offset
	var IDAY = Number(IDay);				// Tag des Datums - Day of the date
	var IMONTH = Number(IMonth);		// Monat des Datums - Month of the date
	var IYEAR = Number(IYear);			// Jahr des Datums - Year of the date
	
	// Aus dem Datum ein julianisches Datum berechnen ...
	//  Calculate a Julian date from the date ...
	var A = calDate2JulDate(IDAY, IMONTH, IYEAR);
	// ... davon das julianische Datum der Epoche J2000 subtrahieren ...
	//  ... subtract the Julian date of the epoch J2000 ...
	var B = A - 2451545.0;
	// ... dann den Teil des vergangenen Jahrhunderts berechnen ...
	//  ... then calculate the part of the last century ...
	var C = B / 36525.0;
	// ... und ber verschiedene Formeln die Sternzeit in Greenwich (GST) berechnen ...
	// ... and calculate the stardate in Greenwich (GST) using different formulas ...
	var D = 6.697374558 + (2400.051336 * C) + (0.000025862 * C * C);
    var E = D - (24 * parseInt(D / 24));
	// ... die lokale Zeit h:m:s in dezimale Zeit umrechnen ...
	// ...  the local time h:m:s convert to decimal time ...
    var F = time2Dectime(LCTHOUR, LCTMIN, LCTSEC, 0)
    var G = F * 1.002737909;
    var H = E + G
	
	// ... und zurck zum Aufrufer .
	// ... and back to the caller.
    return( H - (24 * parseInt(H / 24)));
	
}// End of ut2GreenwichST()



/* *********************************************************************************
 *	Die Funktion  konvertiert  Stundenwinkel h, m, s zu dezimaler RA, 
 * also h, m, s zu dezimalen Stunden xx.yyyyyy.
 * 
 *	bergabewerte:
 *		haHour			= Stundewinkel Stunde, kann hier auch die dezimale Zeit sein
 *		haMin			= Stundewinkel Minute oder 0,  wenn Stunde Dezimalwert ist
 *		haSec			= Stundenwinkel Sekunde oder 0, wenn Stunde Dezimalwert ist
 *		lctHour			= Lokale Zeit in Stunden
 *		lctMin			= Lokale Zeit in Minuten
 *		lctSec			= Lokale Zeit in Sekunden
 *		dst				= Sommer/Winterzeit 0/1
 *		tz					= Zeitzone  -12 <= tz <= 12
 *		IDay				= Lokaler Greenwich Tag der Berechnung
 *		IMonth			= Lokaler Greenwich Monat der Berechnung	
 *		IYear			= Lokales Greenwich Jahr der Berechnung
 *		gLong			= Geografischer Lngengrad der Beobachtung
 *		
 *	Returnwert:
 *		HARA			=	Die RA als dezimaler Stunden Zahlenwert und Number.
 *	---------------------------------------------------------------------------------------------------
 *	 The function converts   hour angle h, m, s to decimal RA, 
 *  So h, m, s to decimal hours xx.yyyyyy.
 * 
 *	 Transfer values:
 *		 haHour		=  Hour angle hour, here can also be the decimal time
 *		 haMin			=  Hour angle  minute or 0,   when hour is a decimal
 *		 haSec			=  Hour angle second or 0 , if hour is decimal
 *		 lctHour		=  Local time in hours
 *		 lctMin			=  Local time in minutes
 *		 lctSec			=  Local time in seconds
 *		 dst				=  Summer /Winter time  0/1
 *		 tz				=  Time zone   -12 < =  tz < =  12
 *		 IDay			=  Local  Greenwich day of calculation
 *		 IMonth		= Local  Greenwich month of calculation	
 *		 IYear			=  Local  Greenwich  Year of calculation
 *		 gLong			=  Geographical longitude of the observation
 *		
 *	 Return value:
 *		 HARA			=	The RA as decimal hours numerical value and number.
 *************************************************************************************** */
function angleHours2RA(haHour, haMin, haSec, lctHour, lctMin, lctSec, dst, tz, IDay, IMonth, IYear, gLong){
	var HARA= 0.0;								// Returnwert die RA 
															// Return value  the RA
	var HAHOUR = Number(haHour);	// Stunden der RA - Hours of RA
	var HAMIN = Number(haMin);			// Minuten der RA - Minutes of RA
	var HASEC = Number(haSec);		// Sekunden der RA - Seconds of RA
	var LCTHOUR = Number(lctHour);	// Stunden der lokalen Zeit - Hours of local time
	var LCTMIN = Number(lctMin);		// Minuten der lokalen Zeit - Minutes of local time
	var LCTSEC = Number(lctSec);		// Sekunden der lokalen Zeit - Seconds of local time
	var DST = Number(dst);					// Sommer/Winterzeit - Daylight saving time offset
	var TZ = Number(tz);						// Zeitzonen Offset - Time zone offset
	var IDAY = Number(IDay);				// Tag des Datums - Day of calculation date
	var IMONTH = Number(IMonth);		// Monat des Datums - Month of calculation date
	var IYEAR = Number(IYear);			// Jahr des Datums - Year of calculation date
	var GLONG = Number(gLong);		// Lngengrad des Beobachters - Observers longitude
	// Zuerst wandeln wir die lokale Uhrzeit in die Universal Time (UT) ...
	//  First we convert the local time to Universal Time (UT)...
	var A = localtime2UT(LCTHOUR, LCTMIN, LCTSEC, DST,  TZ, IDAY, IMONTH, IYEAR);
	// ... und dann Datum, Uhrzeit und Zeitkorrekturen in den Greenwich Tag ...
	// ... and then date, time and time corrections into the Greenwich day ...
	var B = localtime2GreenwichDay(LCTHOUR, LCTMIN, LCTSEC, DST,  TZ, IDAY, IMONTH, IYEAR);
	// ... und dann Datum, Uhrzeit und Zeitkorrekturen in den Greenwich Monat ...
	// ... and then date, time and time corrections into the Greenwich month ...
	var C = localtime2GreenwichMonth(LCTHOUR, LCTMIN, LCTSEC, DST,  TZ, IDAY, IMONTH, IYEAR);
	// ... und dann Datum, Uhrzeit und Zeitkorrekturen in das Greenwich Jahr ...
	// ... and then date, time and time corrections into the Greenwich year ...
	var D = localtime2GreenwichYear(LCTHOUR, LCTMIN, LCTSEC, DST,  TZ, IDAY, IMONTH, IYEAR);
	// ... danach wird die Greenwich Zeit und Datum in die Greenwich Sternzeit konvertiert ...
	//  ... then the Greenwich time and date is converted into the Greenwich Stardate ...
	var E = ut2GreenwichST(LCTHOUR, LCTMIN, LCTSEC, DST,  TZ, IDAY, IMONTH, IYEAR);
	// ... und dann die Greenwich Sternzeit zur lokalen Sternzeit anhand des Lngengrades konvertieren ...
	// ... and then convert the Greenwich stardate to local stardate using longitude ...
	var F = greenwichST2LocalST(E, 0, 0, GLONG);
	// ... H, m, s der RA in dezimalen Wert umrechnen ...
	// ...  Convert H, m, s of RA to decimal value ...
	var G = time2Dectime(HAHOUR, HAMIN, HASEC, 0);
	// ... und die Differenz zwischen lokaler Sternzeit und den Stunden der RA ist der Stundenwinkel ...
	// ... and the difference between local stardate time and the hours of the RA is the hour angle ...
	var H = F - G;
	// ... negativen Stundenwinkel in equvalenten positiven Stundnwinkel verwandeln ...
	//  ... turn negative hour angle into equvalent positive hour angle ...
	if (H < 0)  HARA = 24.0 + H; else HARA = H;
	// ... und zurck zum Aufrufer.
	// ... and back to the caller.
	return(HARA);
	
}// End of angleHours2RA()




/* *********************************************************************************
 *	Die Funktion  konvertiert die quatoriale Right Ascension zu Stunden-
 *	winkeln.
 *	
 *	bergabewerte:
 *		raHour			= Stunde quatoriale RA, kann hier auch die dezimale Zeit sein
 *		raMin			= Minute quatoriale RA oder 0,  wenn Stunde Dezimalwert ist
 *		raSec			= Sekunde quatoriale RA oder 0, wenn Stunde Dezimalwert ist
 *		lctHour			= Lokale Zeit in Stunden
 *		lctMin			= Lokale Zeit in Minuten
 *		lctSec			= Lokale Zeit in Sekunden
 *		dst				= Sommer/Winterzeit 0/1
 *		tz					= Zeitzone  -12 <= tz <= 12
 *		IDay				= Lokaler Greenwich Tag der Berechnung
 *		IMonth			= Lokaler Greenwich Monat der Berechnung	
 *		IYear			= Lokales Greenwich Jahr der Berechnung
 *		gLong			= Geografischer Lngengrad der Beobachtung
 *		
 *	Returnwert:
 *		RAHA			=	Die RA als Stundenwinkel und dezimalen Zahlenwert und Number.
 *	---------------------------------------------------------------------------------------------------
 *	 The function converts the equatorial right ascension to hourly
 *	 Angle.
 *	
 *	 Transfer values:
 *		 raHour			=  Hour equatorial RA, here can also be the decimal time
 *		 raMin			=  minute equatorial RA or 0,   when hour is decimal value
 *		 raSec			=  Second equatorial RA or 0, if hour is decimal
 *		 lctHour		=  Local time in hours
 *		 lctMin			=  Local time in minutes
 *		 lctSec			=  Local time in seconds
 *		 dst				=  Summer /Winter time  0/1
 *		 tz				=  Time zone   -12 < =  tz < =  12
 *		 IDay			=  Local  Greenwich day of calculation
 *		 IMonth		= 	Local  Greenwich Month of Calculation	
 *		 IYear			=  Local  Greenwich  Year of calculation
 *		 gLong			=  Geographical longitude of the observation
 *		
 *	 Return value:
 *		 RAHA			=	The RA as hour angle and decimal value and number.
  *************************************************************************************** */
function ra2HourAngle(raHour, raMin, raSec, lctHour, lctMin, lctSec, dst, tz, IDay, IMonth, IYear, gLong){
	var RAHA = 0.0;								// Returnwert die RA als Stundenwinkel
															// Return value  the RA as hour angle
	var RAHOUR = Number(raHour);		// Stunden der RA - Hours of RA
	var RAMIN = Number(raMin);			// Minuten der RA - Minutes of RA
	var RASEC = Number(raSec);			// Sekunden der RA - Seconds of RA
	var LCTHOUR = Number(lctHour);	// Stunden der lokalen Zeit - Hours of local time
	var LCTMIN = Number(lctMin);			// Minuten der lokalen Zeit - Minutes of local time
	var LCTSEC = Number(lctSec);		// Sekunden der lokalen Zeit - Seconds of local time
	var DST = Number(dst);					// Sommer/Winterzeit - Daylight saving time offset
	var TZ = Number(tz);						// Zeitzonen Offset - Time zone offset
	var IDAY = Number(IDay);				// Tag des Datums - Day of calculation date
	var IMONTH = Number(IMonth);		// Monat des Datums - Month of calculation date
	var IYEAR = Number(IYear);			// Jahr des Datums - Year of calculation date
	var GLONG = Number(gLong);			// Lngengrad des Beobachters - Observers longitude
	// Zuerst wandeln wir die lokale Uhrzeit in die Universal Time (UT) ...
	//  First we convert the local time to Universal Time (UT)...
	var A = localtime2UT(LCTHOUR, LCTMIN, LCTSEC, DST,  TZ, IDAY, IMONTH, IYEAR);
	// ... und dann Datum, Uhrzeit und Zeitkorrekturen in den Greenwich Tag ...
	// ... and then date, time and time corrections into the Greenwich day ...
	var B = localtime2GreenwichDay(LCTHOUR, LCTMIN, LCTSEC, DST,  TZ, IDAY, IMONTH, IYEAR);
	// ... und dann Datum, Uhrzeit und Zeitkorrekturen in den Greenwich Monat ...
	// ... and then date, time and time corrections into the Greenwich month ...
	var C = localtime2GreenwichMonth(LCTHOUR, LCTMIN, LCTSEC, DST,  TZ, IDAY, IMONTH, IYEAR);
	// ... und dann Datum, Uhrzeit und Zeitkorrekturen in das Greenwich Jahr ...
	// ... and then date, time and time corrections into the Greenwich year ...
	var D = localtime2GreenwichYear(LCTHOUR, LCTMIN, LCTSEC, DST,  TZ, IDAY, IMONTH, IYEAR);
	// ... danach wird die Greenwich Zeit und Datum in die Greenwich Sternzeit konvertiert ...
	//  ... then the Greenwich time and date is converted into the Greenwich Stardate ...
	var E = ut2GreenwichST(LCTHOUR, LCTMIN, LCTSEC, DST,  TZ, IDAY, IMONTH, IYEAR);
	// ... und dann die Greenwich Sternzeit zur lokalen Sternzeit anhand des Lngengrades konvertieren ...
	// ... and then convert the Greenwich stardate to local stardate using longitude ...
	var F = greenwichST2LocalST(E, 0, 0, GLONG);
	// ... H, m, s der RA in dezimalen Wert umrechnen ...
	// ...  Convert H, m, s of RA to decimal value ...
	var G = time2Dectime(RAHOUR, RAMIN, RASEC, 0);
	// ... und die Differenz zwischen lokaler Sternzeit und den Stunden der RA ist der Stundenwinkel ...
	// ... and the difference between local stardate time and the hours of the RA is the hour angle ...
	var H = F - G;
	// ... negativen Stundenwinkel in equvalenten positiven Stundnwinkel verwandeln ...
	//  ... turn negative hour angle into equvalent positive hour angle ...
	if (H < 0)  RAHA = 24.0 + H; else RAHA = H;
	// ... und zurck zum Aufrufer.
	// ... and back to the caller.
	return(RAHA);
	
}// End of ra2HourAngle()



/* *********************************************************************************
 *	Die Funktion kopiert den Text eines Eingabefeldes oder einer Textarea
 * komplett in die Zwischenablage. Das Textfeld kann auch disabled sein,
 * also fr das Editieren gesperrt. Am Ende wird das Textfeld auf nicht
 * editierbar gesetzt.
 *	
 *	bergabewert:
 *		objText				= Objekt des Textfeldes
 *		
 *	Returnwert:
 *		Keiner
 *	---------------------------------------------------------------------------------------------------
 *	 The function copies the text of an input field or a text area
 *  completely in the clipboard.  The text field may also be disabled,
 *  thus blocked for editing.  At the end, the text field is set to
 *  set editable.
 *	
 *	 Transfer value:
 *		 objText			=  Object of the text field
 *		
 *	 Return value:
 *		 None
  *************************************************************************************** */
function copyText2Clipboard(objText){

	objText.disabled = false;									// ... Textfeld editierbar machen ...
																			// ... Text field  make editable ...
	objText.focus();												// ... Textfenster im Focus
																			//  ... text window in the Focus
	objText.select();												// ... dann markieren den gesamten Text ...
																			//  ... then mark the entire text ...
	document.execCommand('copy');					// ... und den Text in die Zwischenablage kopieren....
																			// ... and copy the text to the clipboard.
	objText.selectionStart = objText.selectionEnd;	// ... Markierten Text wieder demarkieren.
																			//  ... Demarcate selected text again.
	objText.disabled = true;									// ... Textfeld nicht mehreditierbar machen.
																			//  ... make text field not possible to be re-edited.
}// end of copyText2Clipboard()



/* *********************************************************************************
 *	Die Funktion ermittelt den Nachkommaanteil einer dezimalen Zahl
 * wie 12.345 = 0.345 oder -12.345 = -0.345.
 *	
 *	bergabewert:
 *		num				= Dezimalzahl als Number
 *		
 *	Returnwert:
 *		frac 				= der dezimale Nachkommaanteil als Number
 *	---------------------------------------------------------------------------------------------------
 *	The function determines the decimal part of a decimal number
 *  as 12.345 = 0.345 or -12.345 =  -0.345.
 *	
 *	 Transfer value:
 *		 num			=  Decimal number as number
 *		
 *	 Return value:
 *		 frac 			 =  the decimal part of the decimal point as number
  *************************************************************************************** */
(function(RGX) {
    frac = function(num) {
        return +(+num).toExponential().replace(RGX, function(m, neg, num, dot, offset) {
            var zeroes = Array(Math.abs(offset) + 2).join('0');
            num = (zeroes + num + (dot ? '' : '.') + zeroes).split('.');
            return +(neg + '.' + num.join('').slice(+offset + num[0].length));
        });
    };
})(/(-?)(\d+(\.?)\d*)e(.+)/);




/* *********************************************************************************
 *	Die Funktion Testet die Plausibilitt von Zeitzonenangaben und Lngengradangaben.
 *	Beide mssen bereinstimmen.
 * Eine Zeitzone sind 15 oder auch 1 Stunde, nach Osten mit + Werten und nach Westen
 * mit - Werten. Zu der Zeitzone muss jeweils die richtige Gradangabe passen.
 * Die Zeitzone 1 geht von 0 bis 15 also wre ein gltiger Wert 1 und 7.2225 stlich
 * oder -1 und -7.2225 westlich.
 *	
 *	bergabewert:
 *		tz				= Zeitzone als Ganzzahl von -12 bis + 12
 *		lambda	= Lngengrad des Standortes in dezimalen Grad von -180 bis
 *							+180
 *		
 *	Returnwert:
 *		ret 			= True, wenn die Werte zusammenpassen
 *						= False, wenn sie nicht korrespondieren.
 *	---------------------------------------------------------------------------------------------------
 * The function Tests the plausibility of time zone and longitude data.
 * Both have to match.
 * A time zone is 15 or even 1 hour, to the East with + values and to the West
 * with  values. The correct degree must match the time zone.
 * Time zone 1 goes from 0 to 15 So a valid value would be 1 and 7. 2225 east
 * or -1 and -7. 2225 west.
 *
 * Transfer value:
 * 			tz 			= Time zone as integer from -12 to +12
 * 			lambda 	= Longitude of the site in decimal degrees of -180 to
 * 								+180
 *
 * Return value:
 * 			ret 			= True if the values match
 * 							= False if they dont match.
  *************************************************************************************** */
function testTimezoneAndLongitude(tz, lambda){
	var  ret = false;					// Der Returnwert - Return value
	var TZ  = parseInt(tz);			// Verwendete Zeitzone - Used time zone
	var L = Number(lambda);	// Verwendeter Lngengrad - Used longitude

	// In Greenwich, auf dem 0 Meridian muss TZ = 0 und Lngengrad = 0 sein ...
	// In Greenwich, on the 0 meridian must TZ = 0 and longitude = 0 . . .
	if ((TZ == 0.0) &&(L == 0.0 ) ){
		ret = true;
	// ... und dann alle anderen Werte betrachten ...
	// . . . and then look at all the other values . . .
	} else {

		if ( ( (TZ == 1) && (L > 0.0) && (L <= 15.0)) ||  ( (TZ == -1) && (L <= 0.0) && (L >= -15.0))) 
			ret = true;
		else  if ( ( (TZ == 2) && (L > 15.0) && (L <= 30.0)) ||  ( (TZ == -2) && (L < -15.0) && (L >= -30.0))) 
			ret = true;
		else  if ( ( (TZ == 3) &&(L > 30.0) && (L <= 45.0)) ||  ( (TZ == -3) &&(L < -30.0) && (L >= -45.0)) )
			ret = true;
		else  if ( ((TZ == 4) && (L > 45.0) && (L <= 60.0)) ||  ( (TZ == -4) && (L < -45.0) && (L >= -60.0)) )
			ret = true;
		else  if ( ((TZ == 5)&& (L > 60.0) && (L <= 75.0)) ||  ((TZ == -5) &&(L < -60.0) && (L >= -75.0)) )
			ret = true;
		else  if ( ((TZ == 6)&&(L > 75.0) && (L <= 90.0)) ||  ((TZ == -6)&&(L < -75.0) && (L >= -90.0)) )
			ret = true;
		else  if (  ( (TZ == 7)&&(L > 90.0) && (L <= 105.0)) ||  ((TZ == -7)&&(L < -90.0) && (L >= -105.0)) )
			ret = true;
		else  if (  ( (TZ == 8) && (L > 105.0) && (L <= 120.0)) ||  ( (TZ == -8) &&(L < -105.0) && (L >= -120.0))  )
			ret = true;
		else  if (  ( (TZ == 9) && (L > 120.0) && (L <= 135.0)) ||  ( (TZ == -9) &&(L < -120.0) && (L >= -135.0))  )
			ret = true;
		else  if (  ( (TZ == 10) && (L > 135.0) && (L <= 150.0)) ||  ( (TZ == -10) &&(L < -135.0) && (L >= -150.0))  )
			ret = true;
		else  if (  ( (TZ == 11) && (L > 150.0) && (L <= 165.0)) ||  ( (TZ == -11) &&(L < -150.0) && (L >= -165.0))  )
			ret = true;
		else  if (  ( (TZ == 12) && (L > 165.0) && (L <= 180.0)) ||  ( (TZ == -12) &&(L < -165.0) && (L >= -180.0))  )
			ret = true;
	}
	// ... und zurck zum Aufrufer.
	// ... and back to the caller.
	return (ret);
	
}// End of testTimezoneAndLongitude()




/* *********************************************************************************
 *	Die Funktion berechnet aus Stundenwinkel, Deklination und Breitengrad die Hhe eines
 *	Objekts (Mond ... Sterne ....) ber dem Horizont aus quatorialen Koordinaten. 
 * Es handelt sich dabei um horizontale Koordinaten, aber Achtung, sie kann nur fr
 * quatoriale Koordinaten verwendet werden die bei Auf- und Untergngen berechnet
 * wurden, wie bei der Funktion moonSetAz()oder moonRiseAz(), da Sternzeit
 * Uhrzeiten verwendet werden. 
 *	Man kann hier also nicht mit der Funktion convertEquatorial2Horizontal() arbeiten, 
 * 
 * 
 *	bergabewert:
 *		hourAngle	= Stundenwinkel RA in dezimalen Grad
 *		dec				= Deklination Dec in dezimalen Grad
 *		lat					= Breitengrad in dezimalen Grad
 *		
 *	Returnwert:
 *		h					= Hhe des Objektes in dezimalen Grad
 *	---------------------------------------------------------------------------------------------------
 * The function calculates from hour angle, declination and latitude the height of a
 * Object (Moon . . . Stars . . . . ) above the horizon from equatorial coordinates .
 * These are horizontal coordinates, but be careful, they can only be used for
 * equatorial coordinates are used which are calculated for rises and downsets
 * were, as with the moonSetAz () or moonRiseAz () function, because stardate
 * times are used.
 * So you cant work with the convertEquatorial2Horizontal () function here,
 *
 *
 * Transfer value:
 * 		hourAngle 	= Hour angle RA in decimal degrees
 * 		dec 				= Declination Dec in decimal degrees
 * 		lat 				= Latitude in decimal degrees
 *
 * Return value:
 * 		h 					= Height of the object in decimal degrees
  *************************************************************************************** */
function objectHeight(hourAngle,  dec, lat){
	var h = 0.0;															// Objekthhe als Returnwert
																				// Object height as return value
	var HOURANGLE = Number(hourAngle)/ RAD;	// Der quatoriale Stundenwinkel
																				// The equatorial angle of hour
	var DEC = Number(dec)/ RAD;							// Die quatoriale Deklination
																				// The equatorial declination
	var LAT = Number(lat)/ RAD;								// Der Breitengrad des Standorts
																						// The latitude of the site
	// Ersten Teil berechnen ...
	// Calculate the first part ...
	var A = Math.cos(HOURANGLE) * Math.cos(LAT) * Math.cos(DEC);
	// ... danach den zweiten Teil ...
	// ... and then the second ...
	var B = Math.sin(LAT) * Math.sin(DEC);
	// ... Objekthhe aus dem arcus Sinus von A - B berechnen ...
	// . . . Calculate object height from the arcus sine of A  B . . .
	h = Math.asin(A - B);
	// ... und zurck zum Aufrufer.
	// ... and back to the caller.
	return(h);
	
}// End of objectHeight()



// In der Dokumentation nicht bezeichnete Funktion, die die berechnete
// UT auf einen Tag vorher oder spter setzt, wenn die Differenz < -6
// oder > 6 ist.
// Function not specified in the documentation that performs the calculated function
// UT sets to one day earlier or later if the difference < -6
// or > 6.
function adjustUTDay(ut, g1){
	var UT = Number(ut);
	var G1 = Number (g1);
		// Die Differenz ist grer als 6 Stunden
		// The difference is greater than 6 hours
        if ((UT - G1) <  -6.0)
            UT = UT + 24.0;
        // Die Differenz ist grer als 6 Stunden
		//The difference is greater than 6 hours
        if ((UT - G1) >  6.0)
            UT = UT - 24.0;
	// Korregierte UT Zurck zum Aufrufer
	// Corrected UT back to the caller.
	return(UT);

}// End of adjustUTDay()




/* *********************************************************************************
 *	Die Funktion berechnet bei der Konvertierung von Greenwich Sternzeit zu
 *  Universalzeit (UT)einen eventuellen Fehler. Wird verwendet
 *	in der Funktion moonriseLocalTime().
 *	
 *	bergabewert:
 *		Siehe bergabeparameter und Beschreibung in der Funktion
 *	
 *	Returnwert:
 *		errorUT = Fehler bei der Konvertierung "Warning" oder "OK" als String
 *	---------------------------------------------------------------------------------------------------
* The function calculates when converting from Greenwich to stardate
* Universal Time (UT) a possible error. Is used
* in the moonriseLocalTime () function.
*
* Transfer value:
* 		See transfer parameters and description in the function
*
* Return value:
* 		errorUT = Error when converting Warning or OK to string
  *************************************************************************************** */
function errorGreenwichST2UT(gstHour, gstMinute, gstSecond, gDay, gMonth, gYear){
	// Definition und Initialisieren von bentigten Variablen
	// Definition and initialization of required variables
	var GSTHOUR = Number(gstHour);			// Greenwich ST Stunden dezimal
	var GSTMINUTE = Number(gstMinute);		// Greenwich ST Minuten dezimal
	var GSTSECOND = Number(gstSecond);	// Greenwich ST Sekunden dezimal
																		// Greenwich sidereal time in h, m, s
	var GDAY = parseInt(gDay);						// Greenwich Tag, Monat, Jahr
	var GMONTH = parseInt(gMonth);				// Greenwich day, month, year
	var GYEAR = parseInt(gYear);
	var errorUT = "";											// Fehler UT  als Returnwert
																		// Error UT  as return value
	// Julianisches Datum des Berechnungsdatums um 00:00:00 Uhr berechnen ...
	// Calculate Julian date of the calculation date at 00:00:00 . . .
	var A =  calDate2JulDate(GDAY, GMONTH, GYEAR);
	// .. und ber verschiedene Hilfsvariablen dann die UT ...
	// . . and via different auxiliary variables then the UT . . .
	var B = A - 2451545;
	var C = B / 36525;
	var D = 6.697374558 + (2400.051336 * C) + (0.000025862 * C * C);
	var E = D - (24 * Math.floor(D / 24));
	var F = time2Dectime(GSTHOUR, GSTMINUTE, GSTSECOND, 0);
	var G = F - E;
	var  H = G - (24 * Math.floor(G / 24));
	// ... ermittelt, ob die Rechnung OK ist ...
	// . . . determines whether the calculation is OK . . . 
	if ((H * 0.9972695663) < (4 / 60))
        errorUT = "GST zu UT Warnung";
    else
        errorUT =  "OK";
	// ... dann zurck an den Aufrufer.
	// ... and than back to the caller.
	return(errorUT);

}// End of errorGreenwichST2UT()




/* *********************************************************************************
 *	Die Funktion berechnet aus der Greenwich Sternzeit in h, m, s, und 
 * dem Greenwich Tag, Monat und Jahr des Berechnungsdatums,
 * die dezimale Greenwich Universalzeit (UT).
 *	
 *	bergabewert:
 *		Siehe bergabeparameter und Beschreibung in der Funktion
 *	
 *	Returnwert:
 *		
 *		UT = Greenwich UT in dezimalen Stunden
 *	---------------------------------------------------------------------------------------------------
 * The function is calculated from the Greenwich stardate in h, m, s, and
 * the Greenwich day, month and year of the calculation date,
 * Greenwich Greenwich Universal Time (UT). 
 *
 * Transfer value:
 * 		See transfer parameters and description in the function
 *
 * Return value:
  *		
 * 		UT = Greenwich UT in decimal hours
  *************************************************************************************** */
function greenwichST2UT(gstHour, gstMinute, gstSecond, gDay, gMonth, gYear){
	// Definition und Initialisieren von bentigten Variablen
	// Definition and initialization of required variables
	var GSTHOUR = Number(gstHour);			// Greenwich ST Stunden dezimal
	var GSTMINUTE = Number(gstMinute);		// Greenwich ST Minuten dezimal
	var GSTSECOND = Number(gstSecond);	// Greenwich ST Sekunden dezimal
																		// Greenwich sidereal time in h, m, s
	var GDAY = parseInt(gDay);						// Greenwich Tag, Monat, Jahr
	var GMONTH = parseInt(gMonth);				// Greenwich day, month, year
	var GYEAR = parseInt(gYear);
	var UT = 0.0;												// UT  als Returnwert
																		// UT  as return value
	// Greenwich Julianisches Datum des Berechnungsdatums um 00:00:00 Uhr berechnen ...
	// Calculate Greenwich Julian date of the calculation date at 00:00:00 . . .
	var A =  calDate2JulDate(GDAY, GMONTH, GYEAR);
	// .. und davon dann das Julian. Datum des 1.1.2000 12:00 Uhr subtrahieren ...
	// . . and via different auxiliary variables then the UT . . .
	var B = A - 2451545;
	var C = B / 36525;
	var D = 6.697374558 + (2400.051336 * C) + (0.000025862 * C * C);
	var E = D - (24 * Math.floor(D / 24));
	var F = time2Dectime(GSTHOUR, GSTMINUTE, GSTSECOND, 0);
	var G = F - E;
	var  H = G - (24 * Math.floor(G / 24));
	UT = H * 0.9972695663;
	// ... dann zurck an den Aufrufer.
	// ... and than back to the caller.
	return(UT);

}// End of greenwichST2UT()




/* *********************************************************************************
 *	Die Funktion berechnet aus der lokalen Sternzeit die Greenwich Sternzeit
 * und gibt sie in dezimalen Stunden an den Aufrufer zurck.
 *	
 *	bergabewert:
 *		Siehe bergabeparameter und Beschreibung in der Funktion
 *	
 *	Returnwert:
 *		GST = Greenwich Sternzeit in dezimalen Stunden
 *	---------------------------------------------------------------------------------------------------
 * The function calculates the Greenwich stardate from the local stardate time
 * and returns it to the caller in decimal hours. 
 *
 * 		Transfer value:
 * See transfer parameters and description in the function
 *
 * Return value:
 * 		GST = Greenwich stardate in decimal hours
  *************************************************************************************** */
function lokalST2GreenwichST(localHour, localMinute, localSecond, localLongitude){
	var LOCALHOUR = Number(localHour);						// LST Stunden - LST hours
	var LOCALMINUTE = Number(localMinute);				// LST Minuten - LST minutes
	var LOCALSECOND = Number(localSecond);			// LST Sekunden - LST seconds
	var LOCALLONGITUDE = Number(localLongitude);	// Lokaler Lngengrad . - local longitude
	var LSTGST = 0.0;														// Returnwert die Greenwich ST 
																						// in dezimalen Stunden
																						// Return value GST in decimal hours
	// Die dezimalen Stunden der RA berechnen ...
	// Calculate the decimal hours of the RA . . .
	var A = time2Dectime(LOCALHOUR, LOCALMINUTE, LOCALSECOND, 0);
	// ... Lngengrad des Ortes in Stunden umrechnen ...
	// . . . Convert longitude of the place to hours . . .
	var B = LOCALLONGITUDE / 15.0;
	// ... von der RA subtrahieren ...
	// . . . subtract from the RA . . .
	var C = A - B;
	// ... und GST berechnen ...
	// ... and calculate GST ...
	LSTGST = C - (24.0 * Math.floor(C / 24));
	// Zurck zum Aufrufer.
	// Back to the caller.
	return(LSTGST);
	
}// End of lokalST2GreenwichST()



// Interne Funktion von sunsetLocalTime(), die extern liegt ...
//  Internal function of sunsetLocalTime  (), which is external ...
function sub3710(GD, GM, GY, A, SR, X, Y, DI, GP){
	var ret = new Array();
					
	A = SR + nutationLong(GD, GM, GY) - 0.005694;
	ret.push(A);
	// ... und dann konvertiere ekliptische Koordinaten zu quatorialen Koordinaten fr die RA in Grad ...
	// ...  and then convert ecliptic coordinates to equatorial coordinates for the RA in degrees ...
	X = eclipticCoords2EquatorialRA(A, 0, 0, 0, 0, 0, GD, GM, GY);
	ret.push(X);
	// ... und dann konvertiere ekliptische Koordinaten zu quatorialen Koordinaten fr die Deklination in Grad ...
	// ...  and then convert ecliptic coordinates to equatorial coordinates for declination in degrees ...
	Y = eclipticCoords2EquatorialDec(A, 0, 0, 0, 0, 0, GD, GM, GY);
	ret.push(Y);
	// Die lokale siderische Zeit der RA des Aufgangs berechnen ...
	//  Calculate the local sidereal time of the RA of the rise ...
	LA = setLocalSiderealTime((X/15.0), 0, 0, Y, 0, 0, DI , GP);
	ret.push(LA);
	// ... und dann die Sichtbarkeit des Mondes berprfen, ob er Auf- und Untergeht, niemals
	// zu sehen ist, oder immer zu sehen ist ... kann auch fr die Sonne verwendet werden ...
	// ...  and then check the visibility of the moon to see if it rises and sets, never
	// can be seen, or can always be seen ... can also be used for the Sun ...
	S = visibleStateMoonRiseSet((X / 15.0), 0, 0, Y, 0, 0, DI, GP);
	ret.push(S);
	// ... zurck zum Aufrufer.
	// ... back to the caller
	// A, X, Y, LA, S = Reihenfolge der Returnwerte
	return(ret);
	
}// End of sub3710()


function eSunRS(day, month, year, dst, tz, glong, glat){
 	// bergabeparameter Datentypensicher speichern
	// Transfer parameters Save data type-safe
	var LD = parseInt(day);							// Tag, Monat, Jahr Berechnungsdatum
 	var LM = parseInt(month);						// Day, month, year Calculation date
	var LY= parseInt(year);
	var DS = parseInt(dst);							// Sommer/Winterzeit - Daylight saving time
	var ZC = parseInt(tz);								// Zeitzone - Time zone
	var GL = Number(glong);							// Lngengrad des Orts - Longitude of the place
	var GP = Number(glat);							// Breitengrad des Orts - Latitude of the place
	var GD = 0;												// Grennwich Datum aus lokalem Datum
	var GM = 0;
	var GY = 0;
	var UT = 0.0;											// Grennwich UT
	var eGSTUT = "";										// Fehler bei der Konvertierung 
	var X = 0.0;												// Greenwich Sternzeit - Greenwich siderial time
	var Y = 0.0;												// quatoriale Deklination der Sonne
																	//  Equatorial declination of the Sun
	var A = 0.0;												// Korregierte Longitude der Sonne
																	// Corrected longitude of the sun
	var SR = 0.0;											// Longitude der Sonne
	var LA = 0.0;											// Die lokale siderische Zeit der RA des Aufgangs
																	//  The local sidereal time of the RA of the rise
																	// Longitude of the Sun
	var S = "";												// Sichtbarkeitsstatus der Sonne als String
																	// Visibility of the Sun as string
	var DI	= 0.8333333;								// Das horizontale Shifting mit allen Korrekturen der Sonne
	var ret = new Array();								// Returnwerte aus der Funktion sub3710()
	// Den Tag des Berechnungsdatums um 12:00 Uhr berechnen ...
	// Calculate the day of the calculation date at 12:00 . . .
	GD = localtime2GreenwichDay(12, 0, 0,  DS, ZC, LD, LM, LY);
	// ... und dann Den Tag des Berechnungsdatums um 12:00 Uhr berechnen ...
	// ... and than calculate the month of the calculation date at 12:00 . . .
	GM = localtime2GreenwichMonth(12, 0, 0,  DS, ZC, LD, LM, LY);
	// ... und dann Das Jahr des Berechnungsdatums um 12:00 Uhr berechnen ...
	// ... and than calculate the year of the calculation date at 12:00 . . .
	GY = localtime2GreenwichYear(12, 0, 0,  DS, ZC, LD, LM, LY);
	// ... berechne die Longitude der Sonne zum Berechnungszeitraum ...
	SR = sunLong(12, 0, 0, DS, ZC, LD, LM, LY);
	// ... and then go to function sub3710() ...
	ret = sub3710(GD, GM, GY, A, SR, X, Y, DI, GP);
	// A, X, Y, LA, S = Reihenfolge der Returnwerte
	A = ret[0];
	X = ret[1];
	Y = ret[2];
	LA = ret[3];
	S = ret[4];
	// ... wenn S einen Fehler enthlt, dann Abbruch der Funktion mit einem Fehler ...
	//  ... if S contains an error, then abort the function with an error ...
    if (S != "OK"){
		sub3740();
	// ... und hier geht es weiter ...
	// ...  and here it goes on ...
	}else{
		// Dezimale Greenwich Sternzeit in Stunden aus der lokalen Sternzeit ermitteln ...
		// Decimal Greenwich Determine stardate in hours from the local stardate . . .
		X = lokalST2GreenwichST(LA, 0, 0, GL);
		// ... und aus der Greenwich Sternzeit die Universal Time (UT) berechnen ...
		// . . . and calculate the Universal Time (UT) from the Greenwich Stardate . . .
		UT =  greenwichST2UT(X, 0, 0, GD, GM, GY);
		// ... berechne die Longitude der Sonne zum Berechnungszeitraum ...
		SR = sunLong(UT, 0, 0, 0, 0, GD, GM, GY);
		// ... gehe dann zur Unterfunktion sub3710() ...
		// ... and then go to function sub3710() ...
		ret = sub3710(GD, GM, GY, A, SR, X, Y, DI, GP);
		// A, X, Y, LA, S = Reihenfolge der Returnwerte
		A = ret[0];
		X = ret[1];
		Y = ret[2];
		LA = ret[3];
		S = ret[4];
		sub3740();
	}// End of if(S!= ....)
		
	function sub3740(){	
		// ... und zurck zum Aufrufer.
		// ... and back to the caller.
		return(S);
	}
	// Dezimale Greenwich Sternzeit in Stunden aus der lokalen Sternzeit ermitteln ...
	// Decimal Greenwich Determine stardate in hours from the local stardate . . .
	X = lokalST2GreenwichST(LA, 0, 0, GL);
	// ... und aus der Greenwich Sternzeit die Universal Time (UT) berechnen ...
	// . . . and calculate the Universal Time (UT) from the Greenwich Stardate . . .
	// .  .  .  and calculate the Universal Time (UT) from the Greenwich Stardate .  .  .
	UT =  greenwichST2UT(X, 0, 0, GD, GM, GY);
	// ... Ist bei der Konvertierung der lokalen siserischen Zeit zu Greenwich siderischer
	// Zeit ein Fehler aufgetreten, dann Abbruch ...
	// . . . is sidereal when converting local siseric time to Greenwich more sidereal
	// Time an error occurred, then abort . . .
	if ((eGSTUT = errorGreenwichST2UT(X, 0, 0, GD, GM, GY)) != "OK"){
		S = eGSTUT;
	// ... und hier geht es weiter ...
	// ...  and here it goes on ...
	}
	// ... und zurck zum Aufrufer.
	// ... and back to the caller.
	return(S);
	
}// End of eSunRS()



/* *********************************************************************************
 *	Die Funktion ermittelt, ob der Mond Auf- und Untergeht, ob er niemals
 * zu sehen ist oder immer am Himmel steht.
 *	
 *	bergabewert:
 *		Siehe bergabeparameter und Beschreibung in der Funktion
 *	
 *	Returnwert:
 *		OK	= Auf- und Untergang ist OK
 *		Nie Sichtbar
 *		Immer Sichtbar
 *	---------------------------------------------------------------------------------------------------
 * The function determines whether the Moon rises and goes down, whether it never
 * can be seen or is always in the sky. 
 *
 * Transfer value:
 * See transfer parameters and description in the function
 *
 * Return value:
 * 		OK = rise and fall is OK
 * 		Never Visible
 * 		Always visible
  *************************************************************************************** */
function visibleStateMoonRiseSet(hourRA, minuteRA, secondRA, hourDEC, minuteDEC, secondDEC, vertShiftDegrees, latitudeDegrees){
	var HOURRA = Number(hourRA);								// Winkelstunden der Rektaszension (RA)
																						// Angular hours of right ascension (RA)
	var MINUTERA = Number( minuteRA);						// Winkelminuten der Rektaszension (RA)
																						// Angular minutes of right ascension (RA)
	var SECONDRA = Number(secondRA);						// Winkelsekunden der Rektaszension (RA)
																						// Angular seconds of right ascension (RA)
	var HOURDEC = Number(hourDEC);							// Winkelstunden der Deklination (DEC)
																						// Angular hours of declination (DEC)
	var MINUTEDEC = Number( minuteDEC);					// Winkelminuten der Deklination (DEC)
																						// Angular minutes of declination (DEC)
	var SECONDDEC = Number(secondDEC);					// Winkelsekunden der Deklination (DEC)
																						// Angular seconds of declination (DEC)
	var VERTSHIFTDEGREES = Number(vertShiftDegrees);// Vertikale Verschiebung des Horizont in Grad
																						// Vertical shif of the horizon in degrees
	var LATITUDEDEGREES = Number(latitudeDegrees);// Breitengrad des Orts in Grad
																						// Latitude of the place in degrees
	var eRS = "OK";															// Returnwert als Statusstring
																						// Return valus as status string
																										
	// Dezimale Stunden aus h, m, s der RA berechnen ...
	// Calculate decimal hours from h, m, s of the RA . . .
	var A = time2Dectime(HOURRA, MINUTERA, SECONDRA, 0);
	// ... und diese dezimalen Stunden zu dezimalen Grad konvertieren ...
	// . . . and convert these decimal hours to decimal degrees . . .
	var B = A * 15.0;
	// ... und dann in Radiant ...
	// ... and then as radian ...
	B = B / RAD;
	// ... nun die Winkel als h, m, s der Deklination in dezimalen Winkel umrechnen ...
	// . . . now convert the angles as h, m, s of declination into decimal angle . . .
	var C = time2Dectime(HOURDEC, MINUTEDEC, SECONDDEC, 0);
	// ... und dann in Radiant ...
	// ... and then as radian ...
	C = C / RAD;
	// ... nun die vertikale Verschiebung des Horizont von Grad nach Radiant konvertieren ...
	// . . . now convert the vertical shift of the horizon from degree to radiant . . .
	var D = vertShiftDegrees / RAD;
	// ... nun den Breitengrad in Grad nach Radiant ...
	// . . . now the latitude in degrees by radiant . . .
	var E = LATITUDEDEGREES / RAD;
	// ... und nun die lokale Sternzeit berechnen ...
	// . . . and now calculate the local sidereal time . . .
	var F = -(Math.sin(D) + Math.sin(E) * Math.sin(C)) / (Math.cos(E) *  Math.cos(C) ) ;
	// ... Auswertung der Berechnung ...
    if (F >= 1) eRS = "Nie Sichtbar";
    if (F <= -1) eRS = "Immer Sichtbar";
	// ... und damit zurck zum Aufrufer.
	// ... and this back to the caller.
	return(eRS);
	
}// End of errorStatusRiseSet()



/* *********************************************************************************
 *	Die Funktion berechnet die lokale siderische Zeit (ST)eines Untergangs
 *  anhand der
 * Winkelzeiten h, m, s in Rekaszension (RA) und Deklination (Dec),
 * sowie der vertikalen Verschiebung des Horizonts und dem Breitengrad
 * des Beobachtungsorts.
 *	
 *	bergabewert:
 *		Siehe bergabeparameter und Beschreibung in der Funktion
 *	
 *	Returnwert:
 *		ST in dezimalen Stunden und als Number
 *	---------------------------------------------------------------------------------------------------
 * The function calculates the local sidereal time (ST)of a set from the
 * Angle times h, m, s in recascension (RA) and declination (Dec),
 * as well as the vertical shift of the horizon and the latitude
 * the place of observation. 
 *
 * Transfer value:
 * 		See transfer parameters and description in the function
 *
 * Return value:
 * 		ST in decimal hours and as number
  *************************************************************************************** */
function setLocalSiderealTime(hourRA, minuteRA, secondRA, hourDEC, minuteDEC, secondDEC, vertShiftDegrees, latitudeDegrees){
	var HOURRA = Number(hourRA);									// Winkelstunden der Rektaszension (RA)
																							// Angular hours of right ascension (RA)
	var MINUTERA = Number( minuteRA);							// Winkelminuten der Rektaszension (RA)
																							// Angular minutes of right ascension (RA)
	var SECONDRA = Number(secondRA);							// Winkelsekunden der Rektaszension (RA)
																							// Angular seconds of right ascension (RA)
	var HOURDEC = Number(hourDEC);								// Winkelstunden der Deklination (DEC)
																							// Angular hours of declination (DEC)
	var MINUTEDEC = Number( minuteDEC);						// Winkelminuten der Deklination (DEC)
																							// Angular minutes of declination (DEC)
	var SECONDDEC = Number(secondDEC);						// Winkelsekunden der Deklination (DEC)
																							// Angular seconds of declination (DEC)
	var VERTSHIFTDEGREES = Number(vertShiftDegrees);// Vertikale Verschiebung des Horizont in Grad
																							// Vertical shif of the horizon in degrees
	var LATITUDEDEGREES = Number(latitudeDegrees);	// Breitengrad des Orts in Grad
																							// Latitude of the place in degrees
	// Dezimale Stunden aus h, m, s der RA berechnen ...
	// Calculate decimal hours from h, m, s of the RA . . .
	var A = time2Dectime(HOURRA, MINUTERA, SECONDRA, 0);
	// ... und diese dezimalen Stunden zu dezimalen Grad konvertieren ...
	// . . . and convert these decimal hours to decimal degrees . . .
	var B = (A * 15.0);
	// ... und dann in Radiant ...
	// ... and then as radian ...
	B = B / RAD;
	// ... nun die Winkel als h, m, s der Deklination in dezimalen Winkel umrechnen ...
	// . . . now convert the angles as h, m, s of declination into decimal angle . . .
	var C = time2Dectime(HOURDEC, MINUTEDEC, SECONDDEC, 0);
	// ... und dann in Radiant ...
	// ... and then as radian ...
	C = C / RAD;
	// ... nun die vertikale Verschiebung des Horizont von Grad nach Radiant konvertieren ...
	// . . . now convert the vertical shift of the horizon from degree to radiant . . .
	var D = vertShiftDegrees / RAD;
	// ... nun den Breitengrad in Grad nach Radiant ...
	// . . . now the latitude in degrees by radiant . . .
	var E = LATITUDEDEGREES / RAD;
	// ... und nun die lokale Sternzeit berechnen ...
	// . . . and now calculate the local sidereal time . . .
	var F = -(Math.sin(D) +  Math.sin(E) * Math.sin(C)) / (Math.cos(E) * Math.cos(C));
	// ... bei Werten < 1 Korrekturwert setzen, ansonsten 0 ...
	// . . . for values < 1 set correction value, otherwise 0 . . .
	var H = 0.0;
	if (Math.abs(F) < 1.0)
        H = Math.acos(F);
    else
        H = 0.0;
	// ... und nun dezimale Stunden Winkel zu dezimalen Grad ...
	// . . . and now decimal hours angle to decimal degrees . . .
	var I = ((B + H)* RAD) / 15.0;
	// ... und die lokale siderische Zeit der RA an den Aufrufer zurck.
	// ... and the local siderial time of RA back to the caller.
	return(I - 24 *Math.floor(I / 24.0));
	
}// End of setLocalSiderealTime()



/* *********************************************************************************
 *	Die Funktion berechnet fr den Untergang des Mondes, die 
 * siderische Zeit, am Standort aus RA und Dec, 
 * der vertikalen Verschiebung des Mondes und dem Breitengrad des 
 * Standortes.
 *	
 *	bergabewert:
 *		Siehe bergabeparameter und Beschreibung in der Funktion
 *	
 *	Returnwert:
 *		Siderische Zeit des Untergangs im Azimut in dezimalen Stunden
 *	---------------------------------------------------------------------------------------------------
 * The function calculates for the seting of the Moon, the siderial time,
 * at the location of RA and Dec,
 * of the vertical displacement of the Moon and the latitude of
 * Location.
 *
 * Transfer value:
 * 	See transfer parameters and description in the function
 *
 * Return value:
 * 	Siderial time of the set at AZ in decimal hours
  *************************************************************************************** */
function setLocalSiderealTimeAZ(hourRA, minuteRA, secondRA, hourDEC, minuteDEC, secondDEC, vertShiftDegrees, latitudeDegrees){
	var HOURRA = Number(hourRA);									// Winkelstunden der Rektaszension (RA)
																							// Angular hours of right ascension (RA)
	var MINUTERA = Number( minuteRA);							// Winkelminuten der Rektaszension (RA)
																							// Angular minutes of right ascension (RA)
	var SECONDRA = Number(secondRA);							// Winkelsekunden der Rektaszension (RA)
																							// Angular seconds of right ascension (RA)
	var HOURDEC = Number(hourDEC);								// Winkelstunden der Deklination (DEC)
																							// Angular hours of declination (DEC)
	var MINUTEDEC = Number( minuteDEC);						// Winkelminuten der Deklination (DEC)
																							// Angular minutes of declination (DEC)
	var SECONDDEC = Number(secondDEC);						// Winkelsekunden der Deklination (DEC)
																							// Angular seconds of declination (DEC)
	var VERTSHIFTDEGREES = Number(vertShiftDegrees);// Vertikale Verschiebung des Horizont in Grad
																							// Vertical shif of the horizon in degrees
	var LATITUDEDEGREES = Number(latitudeDegrees);	// Breitengrad des Orts in Grad
																							// Latitude of the place in degrees
	// Dezimale Stunden aus h, m, s der RA berechnen ...
	// Calculate decimal hours from h, m, s of the RA . . .
	var A = time2Dectime(HOURRA, MINUTERA, SECONDRA, 0);
	// ... und diese dezimalen Stunden zu dezimalen Grad konvertieren ...
	// . . . and convert these decimal hours to decimal degrees . . .
	var B = A * 15.0;
	// ... und dann in Radiant ...
	// ... and then as radian ...
	B = B / RAD;
	// ... nun die Winkel als h, m, s der Deklination in dezimalen Winkel umrechnen ...
	// . . . now convert the angles as h, m, s of declination into decimal angle . . .
	var C = time2Dectime(HOURDEC, MINUTEDEC, SECONDDEC, 0);
	// ... und dann in Radiant ...
	// ... and then as radian ...
	C = C / RAD;
	// ... nun die vertikale Verschiebung des Horizont von Grad nach Radiant konvertieren ...
	// . . . now convert the vertical shift of the horizon from degree to radiant . . .
	var D = vertShiftDegrees / RAD;
	// ... nun den Breitengrad in Grad nach Radiant ...
	// . . . now the latitude in degrees by radiant . . .
	var E = LATITUDEDEGREES / RAD;
	// ... und nun die lokale Sternzeit berechnen ...
	// . . . and now calculate the local sidereal time . . .
	var F = -(Math.sin(D) + Math.sin(E) * Math.sin(C)) / (Math.cos(E) * Math.cos(C));
	// ... bei Werten < 1 Korrekturwert setzen, ansonsten 0 ...
	// . . . for values < 1 set correction value, otherwise 0 . . .
	var H = 0.0;
	if (Math.abs(F) < 1.0)
        H = Math.acos(F);
    else
        H = 0.0;
	// ... und nun dezimale Stunden Winkel zu dezimalen Grad ...
	// . . . and now decimal hours angle to decimal degrees . . .
	var I = ((B + H)* RAD) / 15.0;
	// ... und die lokale siderische Zeit der RA an den Aufrufer zurck.
	// ... and the local siderial time of RA back to the caller.
	return(I - 24 * parseInt(I / 24.0));
	
}// End of setLocalSiderealTimeAZ()



/* *********************************************************************************
 *	Die Funktion berechnet fr den Aufgang des Mondes, die 
 * siderische Zeit, am Standort aus RA und Dec, 
 * der vertikalen Verschiebung des Mondes und dem Breitengrad des 
 * Standortes.
 *	
 *	bergabewert:
 *		Siehe bergabeparameter und Beschreibung in der Funktion
 *	
 *	Returnwert:
 *		Siderische Zeit des Aufgangs im Azimut in dezimalen Stunden
 *	---------------------------------------------------------------------------------------------------
 * The function calculates for the rising of the Moon, the siderial time,
 * at the location of RA and Dec,
 * of the vertical displacement of the Moon and the latitude of
 * Location.
 *
 * Transfer value:
 * 	See transfer parameters and description in the function
 *
 * Return value:
 * 	Siderial time of the rise at AZ in decimal hours
  *************************************************************************************** */
function riseLocalSiderealTimeAZ(hourRA, minuteRA, secondRA, hourDEC, minuteDEC, secondDEC, vertShiftDegrees, latitudeDegrees){
	var HOURRA = Number(hourRA);									// Winkelstunden der Rektaszension (RA)
																							// Angular hours of right ascension (RA)
	var MINUTERA = Number( minuteRA);							// Winkelminuten der Rektaszension (RA)
																							// Angular minutes of right ascension (RA)
	var SECONDRA = Number(secondRA);							// Winkelsekunden der Rektaszension (RA)
																							// Angular seconds of right ascension (RA)
	var HOURDEC = Number(hourDEC);								// Winkelstunden der Deklination (DEC)
																							// Angular hours of declination (DEC)
	var MINUTEDEC = Number( minuteDEC);						// Winkelminuten der Deklination (DEC)
																							// Angular minutes of declination (DEC)
	var SECONDDEC = Number(secondDEC);						// Winkelsekunden der Deklination (DEC)
																							// Angular seconds of declination (DEC)
	var VERTSHIFTDEGREES = Number(vertShiftDegrees);// Vertikale Verschiebung des Horizont in Grad
																							// Vertical shif of the horizon in degrees
	var LATITUDEDEGREES = Number(latitudeDegrees);	// Breitengrad des Orts in Grad
																							// Latitude of the place in degrees
	// Dezimale Stunden aus h, m, s der RA berechnen ...
	// Calculate decimal hours from h, m, s of the RA . . .
	var A = time2Dectime(HOURRA, MINUTERA, SECONDRA, 0);
	// ... und diese dezimalen Stunden zu dezimalen Grad konvertieren ...
	// . . . and convert these decimal hours to decimal degrees . . .
	var B = A * 15.0;
	// ... und dann in Radiant ...
	// ... and then as radian ...
	B = B / RAD;
	// ... nun die Winkel als h, m, s der Deklination in dezimalen Winkel umrechnen ...
	// . . . now convert the angles as h, m, s of declination into decimal angle . . .
	var C = time2Dectime(HOURDEC, MINUTEDEC, SECONDDEC, 0);
	// ... und dann in Radiant ...
	// ... and then as radian ...
	C = C / RAD;
	// ... nun die vertikale Verschiebung des Horizont von Grad nach Radiant konvertieren ...
	// . . . now convert the vertical shift of the horizon from degree to radiant . . .
	var D = vertShiftDegrees / RAD;
	// ... nun den Breitengrad in Grad nach Radiant ...
	// . . . now the latitude in degrees by radiant . . .
	var E = LATITUDEDEGREES / RAD;
	// ... und nun die lokale Sternzeit berechnen ...
	// . . . and now calculate the local sidereal time . . .
	var F = -(Math.sin(D) + Math.sin(E) * Math.sin(C)) / (Math.cos(E) * Math.cos(C));
	// ... bei Werten < 1 Korrekturwert setzen, ansonsten 0 ...
	// . . . for values < 1 set correction value, otherwise 0 . . .
	var H = 0.0;
	if (Math.abs(F) < 1.0)
        H = 1.570796327 - (Math.atan(F / Math.sqrt(1 - F * F) + 1 * Math.pow(10, -20)));
    else
        H = 0.0;
	// ... und nun dezimale Stunden Winkel zu dezimalen Grad ...
	// . . . and now decimal hours angle to decimal degrees . . .
	var I = ((B - H)* RAD) / 15.0;
	// ... und die lokale siderische Zeit der RA an den Aufrufer zurck.
	// ... and the local siderial time of RA back to the caller.
	return(I - 24 * parseInt(I / 24.0));
	
}// End of riseLocalSiderealTimeAZ()



/* *********************************************************************************
 *	Die Funktion berechnet fr den Untergang des Mondes, den Azimuth 
 * in dezimalen Grad, am Standort aus RA und Dec, 
 * der vertikalen Verschiebung des Mondes und dem Breitengrad des 
 * Standortes.
 *	
 *	bergabewert:
 *		Siehe bergabeparameter und Beschreibung in der Funktion
 *	
 *	Returnwert:
 *		AZ des Untergangs in dezimalen Grad
 *	---------------------------------------------------------------------------------------------------
	* The function calculates for the seting of the Moon, the azimuth
	* in decimal degrees, at the location of RA and Dec,
	* of the vertical displacement of the Moon and the latitude of
	* Location.
	*
	* Transfer value:
	* 	See transfer parameters and description in the function
	*
	* Return value:
	* 	AZ of the set in decimal degrees
  *************************************************************************************** */
function setLocalSiderealDegreesAZ(hourRA, minuteRA, secondRA, hourDEC, minuteDEC, secondDEC, vertShiftDegrees, latitudeDegrees){
	var HOURRA = Number(hourRA);											// Winkelstunden der Rektaszension (RA)
																									// Angular hours of right ascension (RA)
	var MINUTERA = Number( minuteRA);									// Winkelminuten der Rektaszension (RA)
																									// Angular minutes of right ascension (RA)
	var SECONDRA = Number(secondRA);									// Winkelsekunden der Rektaszension (RA)
																									// Angular seconds of right ascension (RA)
	var HOURDEC = Number(hourDEC);										// Winkelstunden der Deklination (DEC)
																									// Angular hours of declination (DEC)
	var MINUTEDEC = Number( minuteDEC);								// Winkelminuten der Deklination (DEC)
																									// Angular minutes of declination (DEC)
	var SECONDDEC = Number(secondDEC);								// Winkelsekunden der Deklination (DEC)
																									// Angular seconds of declination (DEC)
	var VERTSHIFTDEGREES = Number(vertShiftDegrees);		// Vertikale Verschiebung des Horizont in Grad
																									// Vertical shif of the horizon in degrees
	var LATITUDEDEGREES = Number(latitudeDegrees);			// Breitengrad des Orts in Grad
																									// Latitude of the place in degrees
	// Dezimale Stunden aus h, m, s der RA berechnen ...
	// Calculate decimal hours from h, m, s of the RA . . .
	var A = time2Dectime(HOURRA, MINUTERA, SECONDRA, 0);
	// ... und diese dezimalen Stunden zu dezimalen Grad konvertieren ...
	// . . . and convert these decimal hours to decimal degrees . . .
	var B = A * 15.0;
	// ... und dann in Radiant ...
	// ... and then as radian ...
	B = B / RAD;
	// ... nun die Winkel als h, m, s der Deklination in dezimalen Winkel umrechnen ...
	// . . . now convert the angles as h, m, s of declination into decimal angle . . .
	var C = time2Dectime(HOURDEC, MINUTEDEC, SECONDDEC, 0);
	// ... und dann in Radiant ...
	// ... and then as radian ...
	C = C / RAD;
	// ... nun die vertikale Verschiebung des Horizont von Grad nach Radiant konvertieren ...
	// . . . now convert the vertical shift of the horizon from degree to radiant . . .
	var D = vertShiftDegrees / RAD;
	// ... nun den Breitengrad in Grad nach Radiant ...
	// . . . now the latitude in degrees by radiant . . .
	var E = LATITUDEDEGREES / RAD;
	// ... und nun die lokale Sternzeit berechnen ...
	// . . . and now calculate the local sidereal time . . .
	var F = (Math.sin(C) +  Math.sin(D) * Math.sin(E)) / (Math.cos(D) * Math.cos(E));
	// ... und dann die Sichtbarkeit des Mondes berprfen, ob er Auf- und Untergeht, niemals
	// zu sehen ist, oder immer zu sehen ist ...
	// . . . and then check the visibility of the moon to see if it rises and goes, never
	// can be seen, or can always be seen . . .
	var H = 0.0;
	var eRS = visibleStateMoonRiseSet(HOURRA, MINUTERA, SECONDRA, HOURDEC, MINUTEDEC, SECONDDEC, VERTSHIFTDEGREES, LATITUDEDEGREES);	
	if( eRS == "OK"){
        H = 1.570796327 - (Math.atan(F / Math.sqrt(1 - F * F) + 1 * Math.pow(10, -20)));
    }else
        H = 0.0;
	// ... und nun dezimale Stunden Winkel zu dezimalen Grad ...
	// . . . and now decimal hours angle to decimal degrees . . .
	var I = 360.0 - (H * RAD);
	// ... und den lokalen dezimalen Grad, im richtigen Quadranten, der RA an den Aufrufer zurck.
	// ... and the local decimal degree, in the right area, of RA back to the caller.
	return(I - 360 * Math.floor(I / 360.0));
	
}// End of setLocalSiderealDegreesAZ()



/* *********************************************************************************
 *	Die Funktion berechnet fr den Aufgang des Mondes, den Azimuth 
 * in dezimalen Grad, am Standort aus RA und Dec, 
 * der vertikalen Verschiebung des Mondes und dem Breitengrad des 
 * Standortes.
 *	
 *	bergabewert:
 *		Siehe bergabeparameter und Beschreibung in der Funktion
 *	
 *	Returnwert:
 *		AZ des Aufgangs in dezimalen Grad
 *	---------------------------------------------------------------------------------------------------
	* The function calculates for the rising of the Moon, the azimuth
	* in decimal degrees, at the location of RA and Dec,
	* of the vertical displacement of the Moon and the latitude of
	* Location.
	*
	* Transfer value:
	* 	See transfer parameters and description in the function
	*
	* Return value:
	* 	AZ of the rise in decimal degrees
  *************************************************************************************** */
function riseLocalSiderealDegreesAZ(hourRA, minuteRA, secondRA, hourDEC, minuteDEC, secondDEC, vertShiftDegrees, latitudeDegrees){
	var HOURRA = Number(hourRA);												// Winkelstunden der Rektaszension (RA)
																										// Angular hours of right ascension (RA)
	var MINUTERA = Number( minuteRA);										// Winkelminuten der Rektaszension (RA)
																										// Angular minutes of right ascension (RA)
	var SECONDRA = Number(secondRA);										// Winkelsekunden der Rektaszension (RA)
																										// Angular seconds of right ascension (RA)
	var HOURDEC = Number(hourDEC);											// Winkelstunden der Deklination (DEC)
																										// Angular hours of declination (DEC)
	var MINUTEDEC = Number( minuteDEC);									// Winkelminuten der Deklination (DEC)
																										// Angular minutes of declination (DEC)
	var SECONDDEC = Number(secondDEC);									// Winkelsekunden der Deklination (DEC)
																										// Angular seconds of declination (DEC)
	var VERTSHIFTDEGREES = Number(vertShiftDegrees);			// Vertikale Verschiebung des Horizont in Grad
																										// Vertical shif of the horizon in degrees
	var LATITUDEDEGREES = Number(latitudeDegrees);				// Breitengrad des Orts in Grad
																										// Latitude of the place in degrees
	// Dezimale Stunden aus h, m, s der RA berechnen ...
	// Calculate decimal hours from h, m, s of the RA . . .
	var A = time2Dectime(HOURRA, MINUTERA, SECONDRA, 0);
	// ... und diese dezimalen Stunden zu dezimalen Grad konvertieren ...
	// . . . and convert these decimal hours to decimal degrees . . .
	var B = A * 15.0;
	// ... und dann in Radiant ...
	// ... and then as radian ...
	B = B / RAD;
	// ... nun die Winkel als h, m, s der Deklination in dezimalen Winkel umrechnen ...
	// . . . now convert the angles as h, m, s of declination into decimal angle . . .
	var C = time2Dectime(HOURDEC, MINUTEDEC, SECONDDEC, 0);
	// ... und dann in Radiant ...
	// ... and then as radian ...
	C = C / RAD;
	// ... nun die vertikale Verschiebung des Horizont von Grad nach Radiant konvertieren ...
	// . . . now convert the vertical shift of the horizon from degree to radiant . . .
	var D = vertShiftDegrees / RAD;
	// ... nun den Breitengrad in Grad nach Radiant ...
	// . . . now the latitude in degrees by radiant . . .
	var E = LATITUDEDEGREES / RAD;
	// ... und nun die lokale Sternzeit berechnen ...
	// . . . and now calculate the local sidereal time . . .
	var F = (Math.sin(C) +  Math.sin(D) * Math.sin(E)) / (Math.cos(D) * Math.cos(E));
	// ... und dann die Sichtbarkeit des Mondes berprfen, ob er Auf- und Untergeht, niemals
	// zu sehen ist, oder immer zu sehen ist ...
	// . . . and then check the visibility of the moon to see if it rises and goes, never
	// can be seen, or can always be seen . . .
	var H = 0.0;
	var eRS = visibleStateMoonRiseSet(HOURRA, MINUTERA, SECONDRA, HOURDEC, MINUTEDEC, SECONDDEC, VERTSHIFTDEGREES, LATITUDEDEGREES);	
	if( eRS == "OK"){
        H = 1.570796327 - (Math.atan(F / Math.sqrt(1 - F * F) + 1 * Math.pow(10, -20)));
    }else
        H = 0.0;
	// ... und nun dezimale Stunden Winkel zu dezimalen Grad ...
	// . . . and now decimal hours angle to decimal degrees . . .
	var I = H * RAD;
	// ... und den lokale AZ, im richtigen Quadranten, an den Aufrufer zurck.
	// . . . and the local AZ, in the correct quadrant, back to the caller.
	return(I - 360 * Math.floor(I / 360.0));
	
}// End of riseLocalSiderealDegreesAZ()




/* *********************************************************************************
 *	Die Funktion berechnet die lokale siderische Zeit (ST)eines Aufgangs
 * anhand der Winkelzeiten h, m, s in Rekaszension (RA) und Deklination (Dec),
 * sowie der vertikalen Verschiebung des Horizonts und dem Breitengrad
 * des Beobachtungsorts.
 *	
 *	bergabewert:
 *		Siehe bergabeparameter und Beschreibung in der Funktion
 *	
 *	Returnwert:
 *		ST in dezimalen Stunden und als Number
 *	---------------------------------------------------------------------------------------------------
 * The function calculates the local sidereal time (ST)of a rise from the
 * Angle times h, m, s in recascension (RA) and declination (Dec),
 * as well as the vertical shift of the horizon and the latitude
 * the place of observation. 
 *
 * Transfer value:
 * 		See transfer parameters and description in the function
 *
 * Return value:
 * 		ST in decimal hours and as number
  *************************************************************************************** */
function riseLocalSiderealTime(hourRA, minuteRA, secondRA, hourDEC, minuteDEC, secondDEC, vertShiftDegrees, latitudeDegrees){
	var HOURRA = Number(hourRA);										// Winkelstunden der Rektaszension (RA)
																								// Angular hours of right ascension (RA)
	var MINUTERA = Number( minuteRA);								// Winkelminuten der Rektaszension (RA)
																								// Angular minutes of right ascension (RA)
	var SECONDRA = Number(secondRA);								// Winkelsekunden der Rektaszension (RA)
																								// Angular seconds of right ascension (RA)
	var HOURDEC = Number(hourDEC);									// Winkelstunden der Deklination (DEC)
																								// Angular hours of declination (DEC)
	var MINUTEDEC = Number( minuteDEC);							// Winkelminuten der Deklination (DEC)
																								// Angular minutes of declination (DEC)
	var SECONDDEC = Number(secondDEC);							// Winkelsekunden der Deklination (DEC)
																								// Angular seconds of declination (DEC)
	var VERTSHIFTDEGREES = Number(vertShiftDegrees);	// Vertikale Verschiebung des Horizont in Grad
																								// Vertical shif of the horizon in degrees
	var LATITUDEDEGREES = Number(latitudeDegrees);		// Breitengrad des Orts in Grad
																								// Latitude of the place in degrees
	// Dezimale Stunden aus h, m, s der RA berechnen ...
	// Calculate decimal hours from h, m, s of the RA . . .
	var A = time2Dectime(HOURRA, MINUTERA, SECONDRA, 0);
	// ... und diese dezimalen Stunden zu dezimalen Grad konvertieren ...
	// . . . and convert these decimal hours to decimal degrees . . .
	var B = A * 15.0;
	// ... und dann in Radiant ...
	// ... and then as radian ...
	B = B / RAD;
	// ... nun die Winkel als h, m, s der Deklination in dezimalen Winkel umrechnen ...
	// . . . now convert the angles as h, m, s of declination into decimal angle . . .
	var C = time2Dectime(HOURDEC, MINUTEDEC, SECONDDEC, 0);
	// ... und dann in Radiant ...
	// ... and then as radian ...
	C = C / RAD;
	// ... nun die vertikale Verschiebung des Horizont von Grad nach Radiant konvertieren ...
	// . . . now convert the vertical shift of the horizon from degree to radiant . . .
	var D = vertShiftDegrees / RAD;
	// ... nun den Breitengrad in Grad nach Radiant ...
	// . . . now the latitude in degrees by radiant . . .
	var E = LATITUDEDEGREES / RAD;
	// ... und nun die lokale Sternzeit berechnen ...
	// . . . and now calculate the local sidereal time . . .
	var F = -(Math.sin(D) + Math.sin(E) * Math.sin(C)) / (Math.cos(E) * Math.cos(C));
	// ... bei Werten < 1 Korrekturwert setzen, ansonsten 0 ...
	// . . . for values < 1 set correction value, otherwise 0 . . .
	var H = 0.0;
	if (Math.abs(F) < 1.0)
        H = Math.acos(F);
    else
        H = 0.0;
	// ... und nun dezimale Stunden Winkel zu dezimalen Grad ...
	// . . . and now decimal hours angle to decimal degrees . . .
	var I = ((B - H)* RAD) / 15.0;
	// ... und die lokale siderische Zeit der RA an den Aufrufer zurck.
	// ... and the local siderial time of RA back to the caller.
	return(I - 24 * parseInt(I / 24.0));
	
}// End of riseLocalSiderealTime()



/* *********************************************************************************
 *	Die Funktion bringt eine Gradzahl, die grer als 360 ist in den
 *	Bereich 0 < Grad < 360. Funktioniert auch mit negativen Werten.
 *	
 *	bergabewert:
 *	degrees				= Die Gradzahl als Nubmer
 *	
 *	Returnwert:
 *								= Die korregierte Gradzahl als Number
 *	---------------------------------------------------------------------------------------------------
 * The function brings a degree greater than 360 into the * range 0 < degrees < 360. 
 * Also works with negative values. 
 * 
 * Transfer value: 
 * degrees 				= The degree number as number 
 * 
 * Return value: 
 * 								= The corrected degree number as number
  *************************************************************************************** */
function unwindDeg(degrees){
	var DEGREES = Number(degrees);
	var  DEG = 0.0;
	// Im zweiten Term wird berechnet wie oft man 360
	// subtrahieren muss, also n x 360 und sie von degrees abzieht.
	// Funktioniert auch bei negativen Werten.
	//
	// The second term calculates how many times you have to 
	// subtract 360, so n x 360 and subtract it from degrees. 
	// Also works with negative values.
	DEG = DEGREES - (360.0 * Math.floor(DEGREES / 360.0));
	// ... und zurck zum Aufrufer ...
	// ... and back to the caller ...
	return ( DEG);
}// End of unwindDeg()
	

	
					
/* *********************************************************************************
 *	Die Funktion bringt eine Radiantenzahl, die grer als 6,28... ist in den
 *	Bereich 0 < Rad < 6,28.... Funktioniert auch mit negativen Werten.
 *	
 *	bergabewert:
 *	degrees				= Die Radiantzahl als Number
 *	
 *	Returnwert:
 *								= Die korregierte Radiantzahl als Number
 *	---------------------------------------------------------------------------------------------------
 * The function brings a degree greater than 6,28... into the
 * range 0 < dradians < 6.28.... 
 * Also works with negative values. 
 * 
 * Transfer value: 
 * degrees 				= The radians number as number 
 * 
 * Return value: 
 * 								= The corrected dradians number as number
  *************************************************************************************** */
function unwindRad(r){
	var R = Number(r);
	// PI x 2 ist 6.28....
	var  TWOPI = 6.283185308;
	//console.log ("unwindRad W=" + R);
	var ret = R - TWOPI * Math.floor (R  / TWOPI);

	return (ret );
	
}// End of unwindRad()



/* *********************************************************************************
 *	Die Funktion ermittelt den Nachkommaanteil einer Gleitkommazahl.
 * Z.B. von der Zahl 18.2764 den Wert 0.2764
 *	
 *	bergabewert:
 *	decNumber		= Dezimalzahll als Number
 *	
 *	Returnwert:
 *							= Den Nachkommaanteil als Number
 *	---------------------------------------------------------------------------------------------------
* The function determines the decimal part of a floating-point number. 
* For example from the number 18. 2764 the value 0. 2764
*
* Transfer value:
* decNumber 		= decimal number as number
*
* Return value:
*							= The percentage of decimal places as a number
  *************************************************************************************** */
function decPart(decNumber) {
	var DECNUMBER = Number(decNumber);
	return (DECNUMBER - lInt(DECNUMBER));
	
}//End of decPart()



/* *********************************************************************************
 * Liefert ein vorzeichenrichtigen, abgerundeten Wert von W.
 * Es wird dabei ohne Vorzeichen abgerundet und dann das
 * richtige Vorzeichen wieder verwendet.
 * -400.678 -> -400
 * +400.678 -> +400
 *	
 *	bergabewert:
 *	iint				= Dezimalzahl als Number
 *	
 *	Returnwert:
 *	IINT				= Den Vorzeichenbehafteten Ganzzahlanteil als Number
 *	---------------------------------------------------------------------------------------------------
 * Returns an unsigned, rounded down value of W. 
 * It is rounded down without sign and then the 
 * correct sign is used again. 
 * -400. 678 -> -400 
 * +400. 678 -> +400 
 *
 *	Transfer value: 
 * 	iint 	= Decimal number as number 
 * 
 * Return value: 
 * 	IINT	= The signed integer part as number
  *************************************************************************************** */
function iInt(iint){
		var IINT = Number(iint);
		// Vorzeichen x W abgerundet und vorzeichenfrei
		// Entspricht Fix(W)
		// sign x W rounded and free of sign
		// Corresponds to Fix (W)
		return (Math.sign(IINT) * parseInt(Math.abs(IINT)));
		
}// End of iInt()
						


 
/* *********************************************************************************
 * Gibt unbeachtet des Vorzeichens den ganzzahligen Anteil
 * einer Gleitkommazahl zurck. Es wird immer der nchst
 * kleinere ganzahlige Wert berechnet.
 * -400.234 ->  -401
 * -400			->  -401
 *  400 		->   400
 *  400.234 ->    400
 *	
 *	bergabewert:
 *	lint				= Dezimalzahl als Number
 *	
 *	Returnwert:
 *						= Den Vorzeichenbehafteten Ganzzahlanteil als Number
 *	---------------------------------------------------------------------------------------------------
 * Gives the integer percentage regardless of the sign
 * a floating point number. It will always be the next
 * smaller number of values calculated. * -400. 234 -> -401
 * -400 -> -401
 * 400 -> 400
 * 400. 234 -> 400
 * 400.234 ->    400
 *
 * Transfer value:
 * 	lint 			= decimal number as number
 *
 * Return value:
 *					= The signed integer part as number
 *************************************************************************************** */
function lInt(lint){
	var LINT = Number(lint);
	return (parseInt(LINT) + iInt(((1.0 * Math.sign(LINT)) - 1.0) / 2.0));
								
}// End of lInt()
 
 
 
/* *********************************************************************
	Die Funktion ermittelt die Zeitzone nach dem
	Datum des Rechners. Von -1 bis - 12 und
	von 1 bis 12, je nach Himmelsrichtung entlang
	der Lngengrade.
									
	bergabewert:
	Keiner
											
	Rckgabewert:
	Die Zeitzone als Integer.
	Nach Osten als negativer Wert .
	Nach Westen als positiver Wert			
	----------------------------------------------------
	The function determines the time zone after the
	Date of the computer. from -1 to -12 and
	from 1 to 12, depending on the direction of the sky
	of the lengths.
						
	Transfer value:
	None

	Return value:
	The time zone as an integer. To the east as a negative value.
	To the West as a positive value
 ********************************************************************** */
function getTZ(){
	// Aktuelles Datum ermitteln
	// Get the actual date
	d = new Date();
	// Das Datum vom 1. Januar des aktuellen Jahres
	// The date of 1. January of the current year
	jan = new Date(d.getFullYear(), 0, 1);
	// Das Datum vom 1. Juli des aktuellen Jahres
	// The date of the 1st July of the current year
	jul = new Date(d.getFullYear(), 6, 1);
	// Zeitzonenwert = Timezone + DST
	// Standard ist Winterzeit, also GMT + 1 h 
	//
	// Time zone value = Timezone + DST
	// Standard is winter time, i. e. GMT + 1 h
	TIMEZONE = 0;
	// Differenz zwischen Juli und Januar. Wenn DST dann ist die Differnz 1,
	// ansonsten 0
	//
	// Difference between July and January. If DST is then the Differnce 1,
	// otherwise 0
	diff = 0;
	// Differnz zwischen Juli und Januar des Jahres ermitteln ...
	// Determine the difference between July and January of the year . . .
	diff = jul.getTimezoneOffset()/60 - jan.getTimezoneOffset()/60;
	// ... und an den Aufrufer zurckgeben.
	// ... and back to the caller.
	return(diff);
	
}// End of getTZ()
 
 
 
 /* **************************************************************************
	Ermittelt die Geopositionsdaten und gibt sie aus. Bentigt
	die Callbackfunktionen getGeoPosition() und 
	getGeoPositionError().
	Die Objektvariablen der Ausgabefelder werden der Funktion
	beim Aufruf bergeben. Die Funktion fllt sie dann ber die
	globalen Objekte, hier definiert.
	
	Link zur Anzeige auf Google Maps:
	<a href="https://www.google.de/maps/place//@'+position.coords.latitude+','
				  +position.coords.longitude+ ',16z/">Auf Google Maps anzeigen
	</a>

	Link zur Geodaten Spezifikation:
	https://w3c.github.io/geolocation-api/
	
	bergabewert:
					objLongitude 	= Objekt des Ausgabefeldes Lngengrad
					objLatitude		= Objekt des Ausgabefeldes Breitengrad
					objAccuracy	= Objekt des Ausgabefeldes Genauigkeit

	Rckgabewert ber globale Variablen:
					oLongitude		= Alle analog zu bergabewerten
					oLatitude
					oAccuracy
	---------------------------------------------------------------------------
	Determines and displays the geoposition data. Required
	the callback functions getGeoPosition () and
	getGeoPositionError (). The object variables of the output fields are assigned to the function
	handed over at the call. The function then fills them over the
	global objects, defined here.
	
	Link to the ad on Google Maps:
	<a href="https://www. google. de/maps/place//@'+position. coords. latitude+','
	+position. coords. longitude+',16z/">Show on Google Maps
	</a>

	Link to the Geodata Specification:
	https://w3c. github. io/geolocation-api/

	Transfer value:
					objLongitude = Object of the output field Longitude
					objLatitude = Object of the output field Latitude
					objAccuracy = Object of the output field Accuracy

	Return value over global variables:
					oLongitude = All analogous to transfer values
					oLatitude
					oAccuracy
	************************************************************************* */
var oLongitude;
var oLatitude;
var oAccuracy;
// Ermittelt die Geopositionsdaten
function startGeoPosition(objLongitude, objLatitude, objAccuracy){
	// Globale Variablen oben mit den Objekten der Ausgabefelder fllen.
	oLongitude = objLongitude;
	oLatitude = objLatitude;
	oAccuracy = objAccuracy;
	// Nur, wenn die Daten noch nicht abgerufen wurden noch einmal Laden.
	if (geoPosWasLoaded == false)
		// Browserabfrage des Standortes
		// Browser query of the location
		navigator.geolocation.getCurrentPosition(getGeoPosition, getGeoPositionError,{ 
			maximumAge: Infinity,	// Neue zwischengespeicherte Position wird akzeptiert
			timeout: 100000			// Wartezeit bis eine neu Positionabfrage erstellt wird.
		});
		
}// End of startGeoPosition()



/* **************************************************************************
	Die Funktion ist eine Callbackfunktion fr die Hauptfunktion
	startGeoPosition(objLongitude, objLatitude, objAccuracy).
		
	bergabewert:
								Keiner, wird automatisch bergeben.

	Rckgabewert globale Variablen:
								Siehe startGeoPosition():
								oLongitude	= Objekt des Lngengrades
								oLatitude	= Objekt des Breitengrades
								oAccuracy	= Objekt der Genauigkeit in Metern
	---------------------------------------------------------------------------
	The function is a callback function for the main function 
	startGeoPosition(objLongitude, objLatitude, objAccuracy). 
	
	Transfer value: 
							None, is transferred automatically.
							
	Return value of global variables: 
							See startGeoPosition(): 
							oLongitude = object of longitude 
							oLatitude = object of latitude 
							oAccuracy = object of accuracy in meters
	************************************************************************* */
var geoPos = [];
var geoPosWasLoaded = false;
function getGeoPosition(pos){
	// Ermittelt alle mglichen Daten
	geoPos.push(pos.coords.longitude);				// Lngengrad
	geoPos.push(pos.coords.latitude);					// Breitengrad
	geoPos.push(pos.coords.accuracy);				// Genauigkeit
	geoPos.push(pos.coords.altitude);					// Hhe
	geoPos.push(pos.coords.altitudeAccuracy); 	// Genauigkeit Hhe
	if (geoPos[0] != null)oLongitude.value = geoPos[0]; else oLongitude.value = "N/A";
	if (geoPos[1] != null)oLatitude.value = geoPos[1]; else oLatitude.value = "N/A";
	// Ausgabefeld entfernt - Output field removed
	//if (geoPos[2] != null)oAccuracy.value = geoPos[2]; else oAccuracy.value = "N/A";
	if (geoPos[0] != null &&  geoPos[1] != null && geoPos[2] != null)geoPosWasLoaded = true;
		
}// End of getGeoPosition()
	
	

/* **************************************************************************
	Die Funktion ist eine Callbackfunktion fr die Hauptfunktion
	startGeoPosition(objLongitude, objLatitude, objAccuracy)
	und gibt Fehler in globalen Variablen aus.

	bergabewert:
								= Keiner, wird automatisch bergeben.

	Rckgabewert Globale Variablen:
								= geoPosErr	= Fehler als Nummer
								= geoPosStr 	= Fehler als Text
	---------------------------------------------------------------------------
The function is a callback function for the main function
startGeoPosition (objLongitude, objLatitude, objAccuracy)
and displays errors in global variables.

Transfer value:
								= None, is passed automatically

Return value Global variables:
								= geoPosErr = Error as number
								= geoPosStr = Error as text
	************************************************************************* */
var geoPosErr = 0;
var geoPosStr = "";
function getGeoPositionError(error){

	geoPosErr = error.code;			// Fehlercode als Nummer
	geoPosStr = error.message;		// Fehlercode als Text
	
}// End of getGeoPositionError()
 
 
 
 /* **************************************************************************
	Die Funktion rechnet ekliptische Lngengrade als
	h, m, s  und Breitengrade als , ','' in einen dezimalen Stunden Winkel 
	fr die Deklination um. Es kann ebenso eine dezimaler Winkel
	fr die Stunden von Lngen- und Breitengrad verwendet werden,
	dann mssen Minuten und Sekunden 0 sein.

	bergabewert:
								=	Siehe Funktionskopf

	Rckgabewert:
								=	die Deklination als dezimalen Wert und 
									als Number
	---------------------------------------------------------------------------
	The function calculates ecliptic degrees of length as
	h,m,s and latitude as angle , ', '' in a decimal hour angle
	for the declination. There may also be a decimal angle
	used for the hours of longitude and latitude;
	then minutes and seconds must be 0. 
	
	Transfer value:
								= See function header

	Return value:
								= the declination as a decimal value and
								   as Number	
	************************************************************************* */
 function eclipticCoords2EquatorialDec(eclipHour, eclipMin, eclipSec, latiHour, latiMin, latiSec, calcDay, calcMonth, calcYear){
	var ECLIPHOUR = Number(eclipHour);			// Ekliptische Lnge als Stunde
																			// Ecliptic longitude as a hour
	var ECLIPLONGMIN = Number(eclipMin);		// Ekliptische Lnge als Minute
																			// Ecliptic longitude as a minute
	var ECLIPLONGSEC = Number(eclipSec);		// Ekliptische Lnge als Sekunde
																			// Ecliptic longitude as a second
	var LATIDEG = Number(latiHour);					// Ekliptische Breite als Winkel 
																			// Ecliptic latitude as a angle 
	var LATIMIN = Number(latiMin);						// Ekliptischer Breitengrad als Winkel '
																			// Ecliptic latitude as a angle '
	var LATISEC = Number(latiSec);						// Ekliptischer Breitengrad als Winkel ''
																			// Ecliptic latitude as a angle ''
	var CALCDAY = Number(calcDay);					// Greenwich Berechnungstag
																			// Greenwich Day of Calculation
	var CALCMONTH = Number(calcMonth);		// Greenwich Berechnungsmonat
																			// Greenwich Month of Calculation
	var CALCYEAR = Number(calcYear);				// Greenwich Berechnungsjahr
																			// Greenwich Year of Calculation
	var DEC = 0.0; var A = 0.0; var B = 0.0; var C = 0.0; var D = 0.0; var E = 0.0; 
	// Berechnet die Hilfsvariablen zur Kalkulation. Alle Werte sind in Radianten. Bei den Funktionen
	// sin(9, cos() ... muss also keine explizite Konvertierung mehr statfinden ...
	// ... Grade in dezimalen Grad und dann nach Radiant konverteren ...
	//
	// Calculates the auxiliary variables for calculation. All values are in radiants. With the functions
	// sin (9, cos (). . . doesnt have to find an explicit conversion anymore. . .
	//. . . Longitude in decimal degrees and then converted to radiant. . .
	A = decDegMinSec2decDeg(ECLIPHOUR, ECLIPLONGMIN, ECLIPLONGSEC) / RAD;
	//console.log ("eclipticCoords2Dec eclipHour=" + eclipHour + " - " + "A=" + A);
	// ... Latitude in dezimale Grad und in Radiant konvertieren ...
	//. . . Convert latitude to decimal degrees and radiant. . .
	B = decDegMinSec2decDeg(LATIDEG, LATIMIN, LATISEC) / RAD;
	//console.log ("eclipticCoords2Dec  B="  + B);
	// ... und die ekliptische Schiefe ebenso ...
	//. . . and the ecliptic slope as well. . .
	C = eclipticObliquity(CALCDAY, CALCMONTH, CALCYEAR) / RAD;
	//console.log ("eclipticCoords2Dec  C="  + C);
	// ... D ist der Wert fr den Arkus des Winkel ...
	//. . . D is the value for the arkus of the angle. . .
	D = Math.sin(B) * Math.cos(C) +  Math.cos(B) * Math.sin(C)* Math.sin(A);
	//console.log ("eclipticCoords2Dec  D="  + D);
	// ... und den Winkel als Radianten hier berechnen ...
	//. . . and calculate the angle as radiant here. . .;
	//console.log ("eclipticCoords2Dec  E="  + D);
	E = Math.atan((D  /  Math.sqrt(1 - D* D)) +  (1 * Math.pow(10, -20)));
	//console.log ("E  /  Math.sqrt(1 - E* E) ="  + D  /  Math.sqrt(1 - D* D));
	// ...  und zur dann daraus die dezimale Gradzahl berechnen. ... 
	// . . . and then to calculate the decimal degrees from it. . . .
	DEC = E  *  RAD;
	//console.log ("eclipticCoords2Dec  DEC="  + DEC);
	// ... und DEC zurck zum Aufrufer.
	// ... and DEC back to the Caller.
	return(DEC);
	
 }// End of eclipticCoords2Dec()
 
 
 
  /* *********************************************************************************
	Die Funktion konvertiert ekliptische Koordinaten von Grad, Minute, Sekunde
	in dezimalen Grad.
	
	bergabewerte:
		eclipDeg		= Ekliptische Grad
		eclipMin		= Ekliptische Minute
		eclipSec		= Ekliptische Sekunde
	
	Returnwert:
		Ekliptischer Grad als Dezimalwert.
	---------------------------------------------------------------------------------------------------
	The function converts ecliptic coordinates from degrees, minute, second to 
	decimal degrees.
	
	Transfer values:
		eclipDeg 		= Ecliptic degrees 
		eclipMin 		= Ecliptic minute 
		eclipSec 		= Ecliptic second 
	
	Return value: 
		Ecliptic degrees as decimal value.
  *************************************************************************************** */
 function decDegMinSec2decDeg(eclipDeg, eclipMin, eclipSec){
	 var DMSDD = 0.0; var A = 0.0; var B = 0.0; var C = 0.0;
	 var ECLIPDEG = Number (eclipDeg);
	 var ECLIPMIN = Number (eclipMin);
	 var ECLIPSEC = Number (eclipSec);

    // Stunde+ Minute/60 + Sekunde/60 ...
	// Degrees + Minutes/60 + Seconds/60 ...
    A = Math.abs(ECLIPSEC) /  60.0;
    B = (Math.abs(ECLIPMIN) +  A) /  60.0;
    C = Math.abs(ECLIPDEG) +  B;

    // Ist ein bergabewert kleiner 0, dann Ergebnis negativ
    // und damit Returnert positiv machen ...
	// If a transfer value is less than 0, then result negative
	// and thus make Returnert positive . . .
    if ( (ECLIPDEG <  0.0) || (ECLIPMIN <  0.0) || (ECLIPSEC < 0.0) )
		// ... indem man mit -1 multipliziert ...
        DMSDD = C * -1;
    // ... ansonsten Returnwert als positiv speichern ...
	//. . . otherwise save return value as positive. . .
    else
        DMSDD = C;
	// ... und zurck zum Aufrufer.
	// ... and back to the caller.
	return(DMSDD);
	
 }// End of decDegMinSec2decDeg
  
 

   /* *********************************************************************************
	Die Funktion emittelt einen etwas anderen Arcus Tangens der beiden
	bergabeparameter x und y als Radiant.
	
	bergabewerte:
		x	= Ankathete des Winkels als Number
		y = Gegenkatethe des Winkels als Number
		
	Returnwert:
		Arkus Tangens als Radiant.
	---------------------------------------------------------------------------------------------------
	The function emits a slightly different Arcus tangens of the two
	Transfer parameters x and y as radiant. 
	
	Transfer values:
		x = Ankathete of the angle as number
		y = counter-cathete of the angle as number
		
	Return value:
		Arkus Tangens as a radiant.
  *************************************************************************************** */
 function anotherArcTan(x, y) {
	var X = Number(x);
	var Y = Number(y);
	var B = Math.PI;
	var A = 0.0;
	// Ankathete quasi 0.0 ...
	// Ankathete almost 0. 0 . . .
    if (Math.abs(X) <  (1 * Math.pow(10, -20))){
		// ... dann arbeite bei Gegenkatethe negativ mit positivem
		// PI Halbe
		// . . . then work negatively with positive at Gegenkatethe
		// PI Half
        if (Y < 0.0)
            A = (B  * -1)/ 2.0;
		// ... und hier im positiven Fall mit PI Halbe ...
		// . . . and here in the positive case with PI Half . . .
        else
            A = B / 2.0;
	// Ankathete nicht 0.0 ...
	// Ankathete not 0. 0 . . .
    }else{
		// ... und berechne mit normalem Arkus Tangens ...
		//. . . and calculate with normal Arkus tangens. . .
        A = Math.atan(Y / X);
	}
    // ... wenn die Ankathethe negativ ist, dann mache sie mit PI positiv ...
	//. . . if the ankatheth is negative, then make it positive with PI. . .
    if (X < 0.0)A = B + A;
	// ... und wenn das Ergebnis negativ ist dann rechne 2 x PI dazu und
	// mache es positiv ...
	// . . . and if the result is negative then count 2 x PI to it and
	// make it positive. . .
    if (A < 0.0)A = A + (2 * B);
	// ... und zurck zum Aufrufer.
	// ... and back to the caller.
    return(A);
	
}// End of anotherArcTan()
 

 
  /* *********************************************************************************
	Die Funktion berechnet die Schiefe der Nutation in dezimalen Grad Sekunden
	anhand des Berechnungsdatums.
	Wird von der Funktion eclipticObliquity() bentigt.
	
	bergabewerte:
		gd					= Tag der Berechnung als Number
		gm					= Monat der Berechnung als Number
		gy						= Jahr der berechnung als Number
	
	Returnwert:
		NUTATOBLIQ 	= Die Schiefe der Nutation in dezimalen Grad Sekunden
									als Number
	---------------------------------------------------------------------------------------------------
	The function calculates the skewness of the nutation in decimal degrees 
	seconds based on the calculation date. Required by the eclipticObliquity()
	function. 
	
	Transfer values: 
		gd 					= Day of calculation as Number 
		gm 					= Month of calculation as Number 
		gy 					= Year of calculation as Number 
	
	Return value: 
		NUTATOBLIQ 	= The skewness of the nutation in decimal degrees seconds 
									as Number
  *************************************************************************************** */
function nutationObliquity(gd, gm, gy){
	var GD = Number(gd);		// Tag der Berechnung - Calculated day
	var GM = Number(gm);	// Monat der Berechnung - Calculated month
	var GY = Number(gy);		// Jahr der Berechnung - Calculated year
	var NUTATOBLIQ = 0.0;	// Ergebnis - Result
	// Berechne das modifizierte julianische Datum anhand des Berechnungsdatums ...
	// Calculate the modified Julian date from the calculation date ...
    var JD = calDate2JulDate(GD, GM, GY) - 2415020.0 ; 
	// ... dann den Teil des vergangenen Jahrhunderts ...
	// . . . then the part of the last century . . .
	var T = JD / 36525.0;
	// ... und das zum Quadrat ...
	// ... and that squared ...
	var T2 = T * T;
	// ... und damit und Hilfsvariablen in Radiant ...
	// . . . and with it and auxiliary variables in Radiant . . .
    var A = 100.0021358 * T;
	var B = 360.0 * (A - Math.floor(A));
    var L1 = 279.6967 + 0.000303 * T2 + B;
	var L2 = 2.0 * L1/RAD;
    A = 1336.855231 * T;
	B = 360.0 * (A - Math.floor(A));
    var D1 = 270.4342 - 0.001133 * T2 + B;
	var D2 = 2.0 * D1/RAD;
    A = 99.99736056 * T;
	B = 360.0 * (A - Math.floor(A));
    var M1 = 358.4758 - 0.00015 * T2 + B;
	M1 = M1/RAD;
    A = 1325.552359 * T;
	B = 360.0* (A - Math.floor(A));
    var M2 = 296.1046 + 0.009192 * T2 + B;
	M2 = M2/RAD;
    A = 5.372616667 * T;
	B = 360.0 * (A - Math.floor(A));
    var N1 = 259.1833 + 0.002078 * T2 - B
	N1 = N1/RAD;
    var N2 = 2 * N1;
	// ... berechne das Ergebnis anhand der Reihenentwicklung ...
	// . . . calculate the result using the series expansion . . .
    var DDO = (9.21 + 0.00091 * T) * Math.cos(N1);
    DDO = DDO + (0.5522 - 0.00029 * T) * Math.cos(L2) - 0.0904 * Math.cos(N2);
    DDO = DDO + 0.0884 * Math.cos(D2) + 0.0216 * Math.cos(L2 + M1);
    DDO = DDO + 0.0183 * Math.cos(D2 - N1) + 0.0113 * Math.cos(D2 + M2);
    DDO = DDO - 0.0093 * Math.cos(L2 - M1) - 0.0066 * Math.cos(L2 - N1);
	// .. das Ergebnis in dezimalen Grad Sekunden umrechnen ...
	// . . . convert the result to decimal degrees seconds . . .
    NUTATOBLIQ = DDO / 3600.0;
	// ... und zurck an den Aufrufer.
	// ... and back to the caller.
	return(NUTATOBLIQ);
	
}// End of  nutationObliquity()
  
 


  /* *********************************************************************************
	Die Funktion berechnet die Schiefe der Ekliptik in dezimalen Grad anhand 
	des Berechnungsdatums.
	
	bergabewerte:
		gd		= Tag der Berechnung als Number
		gm		= Monat der Berechnung als Number
		gy			= Jahr der berechnung als Number
	
	Returnwert:
		OBLIQ = Die Schiefe der Ekliptik in dezimalen Grad als Number
	---------------------------------------------------------------------------------------------------
	The function calculates the incline of the ecliptic in decimal degrees from
	the date of calculation.
	
	Transfer values:
		gd 		= day of calculation as number
		gm 		= month of calculation as number
		gy 		= year of calculation as number

	Return value:
		OBLIQ = The incline of the ecliptic in decimal degrees as a number
  *************************************************************************************** */
 function eclipticObliquity(gd, gm, gy){
	var GD = Number(gd);			// Tag der Berechnung - Calculated day
	var GM = Number(gm);		// Monat der Berechnung - Calculated month
	var GY = Number(gy);			// Jahr der Berechnung - Calculated year
	var OBLIQ = 0.0;					// Ergebnis - Result
	// Berechne das julianische Datum ...
	// Calculate the julian date ...
    var A = calDate2JulDate(GD, GM, GY);
	// ... und ber die verschiedenen Hilfsvariablen und Formeln ...
	// ... and over many auxilary variables and formulas ...
    var B = A - 2415020.0;
    var C = (B / 36525.0) - 1.0;
    var D = C * (46.815 + C * (0.0006 - (C * 0.00181)));
    var E = D / 3600.0;
	// ... das Ergebnis der ekliptischen Schiefe mit der Schiefe der Nutation
	// ... the result of obliquity with the obliquity of nutation ...
    OBLIQ = 23.43929167 - E + nutationObliquity(GD, GM, GY);
	// ... und dann zurck zum Aufrufer.
	// ... and than back to the caller.
	return(OBLIQ);

 }// End of eclipticObliquity()
 
 
 
 
 /* *********************************************************************************
	Die Funktion berechnet aus der Longitude in h, m, s
	und der Latitude in Stunden , ' und '' sowie dem Greenwich Berechnungs-
	datum die Rekazension in dezimalen Grad.
	
	Wenn eclipHour als dezimale Stunde, z.B. 214.867 ...., angegeben wird oder
	latiHour als dezimale Stunde, z.B. 1.7160..., angegeben wird, dann mssen
	die Minuten und Sekunden des Lngen- und Breitengrads als 0 angegeben
	werden.
	
	bergabewerte:
		eclipHour 	= Ecliptic Longitude  in Stunden Grad 
		eclipMin 	= Ecliptic Longitude Stunden Minute
		eclipSec 	= Ecliptic Longitude Stunden Second
		latiHour  	= Latitude decimal in Winkel 
		latiMin  	=  Latitude Minute in Winkel '
		latiSec 		=  Latitude Second in Winkel ''
		calcDay  	= Greenwich Berechnungstag
		calcMonth= Greenwich Berechnungsmonat
		calcYear	= Greenwich Berechnungsjahr
	
	Return wert:
		RA 			= Rekazension in dezimalen Grad und als Number
	---------------------------------------------------------------------------------------------------
	The function calculates the recasension in decimal degrees from the 
	longitude in h, ms, s and the latitude in , 
	' and '' as well as the calculation date .
	
	If eclipHour is defined as a decimal hour, e. g. e. g. 214. 867 . . . . , 
	or latiHour is given as a decimal hour, e. g. B. 1. 7160. . . , then the minutes 
	and seconds of the longitude and latitude must be given as 0.
	
	Transfer Values:
		eclipHour 	= Ecliptic Longitude  in hour degrees 
		eclipMin 	= Ecliptic Longitude hour minutes
		eclipSec 	= Ecliptic Longitude hour seconds
		latiHour 	= Latitude decimal in angle 
		latiSec  	=  Latitude minute in angle '
		latiSec  	=  Latitude second in angle ''
		calcDay  	= Greenwich calculation day
		calcMonth = Greenwich calculation month
		calcYear  	= Greenwich calculation year
		
	Return Value:
		RA 			= Rekazension in decimal degrees and as number
  *************************************************************************************** */
 function eclipticCoords2EquatorialRA(eclipHour, eclipMin, eclipSec, latiHour, latiMin, latiSec, calcDay, calcMonth, calcYear){
	var ECLIPHOUR = Number(eclipHour);
	var ECLIPLONGMIN = Number(eclipMin);	
	var ECLIPLONGSEC = Number(eclipSec);		
	var LATIDEG = Number(latiHour);	
	var LATIMIN = Number(latiMin);	
	var LATISEC = Number(latiSec);	
	var CALCDAY = Number(calcDay);	
	var CALCMONTH = Number(calcMonth);	
	var CALCYEAR = Number(calcYear);	
	var RA = 0.0; var A = 0.0; var B = 0.0; var C = 0.0; var D = 0.0; var E = 0.0; var F = 0.0;
	
	// Berechnet die Hilfsvariablen zur Kalkulation. Alle Werte sind in Radianten. Bei den Funktionen
	// sin(9, cos() ... muss also keine explizite Konvertierung mehr statfinden ...
	// ... Grade in dezimalen Grad und dann nach Radiant konverteren ...
	//
	// Calculates the auxiliary variables for calculation. All values are in radiants. With the functions
	// sin (9, cos (). . . doesnt have to find an explicit conversion anymore. . .
	//. . . Longitude in decimal degrees and then converted to radiant. . .
	//console.log("Degrees=" + ECLIPHOUR  );
	A = decDegMinSec2decDeg(ECLIPHOUR, ECLIPLONGMIN, ECLIPLONGSEC) / RAD;
	//console.log("eclipticCoords2RA A=" + A);
	// ... Latitude in dezimale Grad und in Radiant konvertieren ...
	//. . . Convert latitude to decimal degrees and radiant. . .
	B = decDegMinSec2decDeg(LATIDEG, LATIMIN, LATISEC) / RAD;
	//console.log("eclipticCoords2RA B=" + B);
	// ... und die ekliptische Schiefe ebenso ...
	//. . . and the ecliptic slope as well. . .
	C = eclipticObliquity(CALCDAY, CALCMONTH, CALCYEAR) / RAD;
	//console.log("eclipticCoords2RA C=" + C);
	// ... D ist y ...
	D = Math.sin(A) * Math.cos(C) - Math.tan(B) * Math.sin(C);
	//console.log("eclipticCoords2RA D=" + D);
	// ... E ist x ...
	E = Math.cos(A);
	//console.log("eclipticCoords2RA E=" + E);
	// ... dann den arcus Tangens aus y und x bilden
	// . . . then form the arcus tangens from y and x
	F = anotherArcTan(E, D);
	//console.log("eclipticCoords2RA anotherArcTan(E, D)=" + F);
	// ...  und zur dann daraus die dezimale Gradzahl berechnen. ... 
	// . . . and then to calculate the decimal degrees from it. . . .
	RA = (F  *  (180.0/Math.PI))-  (360.0 * Math.floor(F / 360.0));
	//console.log("eclipticCoords2RA RA=" + RA);
	// ... und RA zurck zum Aufrufer.
	// ... and RA back to the Caller.
	return(RA);
	
 }// End of eclipticCoords2RA()



/* *********************************************************************************
	Die Funktion ffnet ein Popup Fenster. Dazu muss im Browser
	das Blockieren von Popups ausgeschaltet sein. Das Fenster wird
	in einer bestimmten Gre erstellt und kann in der Gre verndert
	werden.
	
	bergabewert:
		url 					= der Pfad zu der Datei als String
		windowName	= Der Fenstername als String
		width				= Breite des Fensters in Pixel und als Integer
		height				= Hhe des Fensters in Pixel und als Integer
	
	Returnwert:
		Objekt auf das Fenster. Kann zum Schlieen als Objekt.close()
		benutzt werden.
	---------------------------------------------------------------------------------------------------
	The function opens a popup window. To do this, the blocking of pop-ups must 
	be deactivated in the browser. The window is created in a certain size and 
	can be resized. 

	Pass value: 
		url 					= the path to the file as string 
		windowName 	= the window name as string 
		width 				= width of the window in pixels and as integer 
		height 				= height of the window in pixels and as integer 

	Return value: 
		object on the window. Can be used as object. close() for closing.
  *************************************************************************************** */
function openNew(url, windowName, width, height){
	// Fenster auf die Mitte des Bildschirmes ...
	// Window on the center of the screen . . .
	var browserX = (screen.width / 2) - (width / 2);
	var browserY = (screen.height / 2) - (height / 2);
	// ... wenn nicht schon das Fenster offen ist ...
	// . . . if the window is not already open . . .
	if ( (typeof popup_window == "undefined") || (popup_window.closed == true)){
		// ... ffne ein neues Fenster mit den Parametern ...
		// . . . open a new window with the parameters . . .
		popup_window = window.open(url ,windowName, "screenx=" + browserX + ", screeny=" + browserY + ", toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=no, resizable=no, copyhistory=no, width=" + width + ", height=" + height + "" );
		// ... und wenn der Popup Blocker eingeschaltet ist, geben eine Meldung aus ...
		// . . . and if the Popup Blocker is activated, a message is displayed. . .
		if (popup_window == null)
			alert("Pop-up Blocker ist eingeschaltet! \n Bitte fge diese Seite zur Erlaubtliste des Browsers hinzu!");
	}
	// ... und zurck zum Aurufer .
	// . . . and back to the caller.	
	return (popup_window);
	
}// End of openNew()


/* *********************************************************************************
 *	Die Funktion wandelt eine Gradzahl wie 324,5632 in einen Radianten
 * der Form 5,66.... .
 *	
 *	bergabewert:
 *	degrees				= Die Gradzahl als Number
 *	
 *	Returnwert:
 *								= Die Radiantzahl als Number
 *	---------------------------------------------------------------------------------------------------
 * The function converts a degree like 324. 5632 into a radian 
 * of the form 5. 66. . . . . 
 * 
 * Transfer value:
 * degrees 				= The number of degrees 
 * 
 * Return value: 
 * 								= The number of radians
  *************************************************************************************** */
function deg2Radians(degrees){
	var DEGREES = Number(degrees);
	// PI / 180 ist 0.017453....
	return(DEGREES * 0.01745329252);
	
}// End of  deg2Radians()



/* *********************************************************************************
	Die Funktion ermittelt die Daylight Savings Time und gibt True bei
	Sommerzeit und False bei Winterzeit an den Aufrufer zurck.
	
	Es darauf zu achten, dass der Monat bei den Date Objekten
	beginnt 0 beginnt. Also 0 = Januar und 11 = Dezember.
						
	bergabewert:
		d						= Objekt des aktuellen Datums als Date()Objekt
						
	Returnwert:
		Sommerzeit		= true
		Winterzeit			= false
	---------------------------------------------------------------------------------------------------
	The function determines the Daylight Savings Time and returns True at
	Daylight Saving Time and False at winter time back to the caller.
	
	Make sure that the month in the date objects
	by 0 starts. So 0 = January and 11 = December.

	Transfer value:
		d 						= object of the current date as Date () object

	Return value:
		Summer time	= true
		Winter time 		= false
  *************************************************************************************** */
function isDST (da) {
	var ret = false;
	var JAN = 0; JUL = 0;
	// Das Datum vom 1. Januar des aktuellen Jahres ...
	// The date from 1. January of the current year . . .
	var jan = new Date(da.getFullYear(), 0, 1);
	// Das Datum vom aktuellen Monat des aktuellen Jahres, aktueller Tag,
	// aber da getMonth() immer den Monat - 1 zurck gibt muss man 1 Tag
	// hinzuzhlen...
	// The date of the current month of the current year, current day,
	// but since getMonth () always returns the month  1 you have to 1 day
	// add...
	var jul = new Date(da.getFullYear(), da.getMonth() + 1, da.getDay());
	// ... und jetzt fr die Monate den Offset mit dem aktuellen Jahr
	// ermitteln ...
	// . . . and now determine the offset for the months with the current year . . .
	JAN = jan.getTimezoneOffset();
	JUL = jul.getTimezoneOffset();			
	// ... die Zeitzone nach Osten Werte negativ...
	// . . . the time zone to the east values negative . . .
	if (JAN < 0 && JUL < 0){
		// ... Im Juli kleinerer Wert, also Sommerzeit ...
		// . . . in July smaller value, i. e. summer time ...
		if (JUL < JAN)
			ret = true;
		// ... Winterzeit ...
		// ... Winter time ...
		else if (JUL == JAN)
			ret = false;
	// ... Zeitzone nach Westen Werte positiv ...
	// ... Time zone to the west values positive ...
	} else if (JAN > 0 && JUL > 0){
			// ... Im Juli kleinerer Wert, also Sommerzeit ...
			// . . . in July smaller value, i. e. summer time ...
			if (JUL < JAN){
				ret = true;
			// ... Winterzeit ...
			// ... Winter time ...
			}else if (JUL == JAN){
				ret = false;
			// ... Zeitzone Greenwich ...
			// ... Timezone Greenwich ...
			}else if (JAN == 0 && JUL == 0){
				ret = false;
			// ... Nicht logischer Wert.
			// ... Non logical value.
			}else{
				ret = false;
			}
	}
	// ... und zurck zum Aurufer .
	// . . . and back to the caller.	
	return (ret);
	
}// End of isDST()
